'''
Created on 30/nov/2011

@author: mario
'''

import gtk


def writeBLwantedXML(xmlOut,listID,partList,includeQty,wantNotify,saleQueries,partCondition):
    
    xmlOut.write('<INVENTORY>\n')
    for b in partList:
        xmlOut.write('  <ITEM>\n')
        xmlOut.write('    <ITEMTYPE>{0}</ITEMTYPE>\n'.format(b[0]))
        xmlOut.write('    <ITEMID>{0}</ITEMID>\n'.format(b[1]))
        xmlOut.write('    <COLOR>{0}</COLOR>\n'.format(b[3]))
        if includeQty:
            xmlOut.write('    <MINQTY>{0}</MINQTY>\n'.format(b[2]))
        if wantNotify:
            xmlOut.write('    <NOTIFY>{0}</NOTIFY>\n'.format('Y'))
        else:
            xmlOut.write('    <NOTIFY>{0}</NOTIFY>\n'.format('N'))
        if saleQueries:
            xmlOut.write('    <WANTEDSHOW>{0}</WANTEDSHOW>\n'.format('Y'))
        else:
            xmlOut.write('    <WANTEDSHOW>{0}</WANTEDSHOW>\n'.format('N'))
        if partCondition == 1:
            xmlOut.write('    <CONDITION>{0}</CONDITION>\n'.format('N'))
        elif partCondition == 2:
            xmlOut.write('    <CONDITION>{0}</CONDITION>\n'.format('U'))
        if len(listID) > 0:
            xmlOut.write('    <WANTEDLISTID>{0}</WANTEDLISTID>\n'.format(listID))
        xmlOut.write('  </ITEM>\n')
    xmlOut.write('</INVENTORY>\n')


class BLExportXML(gtk.Dialog):
    '''
    classdocs
    '''
    
    
    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
            if not self.listID.get_text().isdigit() and len(self.listID.get_text()) > 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="List ID must be numeric.")
                msg.set_title('Bad list ID')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return                
                
            if len(self.fileOutput.get_text()) == 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="No output file is given, cannot export.")
                msg.set_title('No output file given')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            try:
                xmlOut = open(self.fileOutput.get_text(),'w')
            except IOError as e:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="Cannot open output file, reason:"+repr(e))
                msg.set_title('Error opening file')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            
            writeBLwantedXML(xmlOut,self.listID.get_text(),self.currList,self.includeQty.get_active(),
                             self.wantNotify.get_active(),self.saleQueries.get_active(),self.partCondition.get_active())
            xmlOut.close()            
                
                
                
        
        
    def fileChooseCB(self,widget):
        dlg = gtk.FileChooserDialog(title='Output file',parent=self,action=gtk.FILE_CHOOSER_ACTION_SAVE,
                                    buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT))
        dlg.set_do_overwrite_confirmation(True)
        response = dlg.run()
        dlg.hide()
        if response == gtk.RESPONSE_ACCEPT:
            self.fileOutput.set_text(dlg.get_filename())
            
        

    def __init__(self,title="Export as Bricklink XML mass upload", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT), 
                 currList=None,catalog=None):
        '''
        Constructor
        '''
        super(BLExportXML, self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        
        self.currList = currList
        self.catalog = catalog
        
        #----------------------------------------------------------- main window
        self.connect('response',self.responseCB)
      
        #-------------------------------------------------------- primary layout
        self.vBox = self.get_content_area()
        self.set_default_size(600,-1)
        table = gtk.Table(2,4)
        self.listID = gtk.Entry()
        self.includeQty = gtk.CheckButton('Include quantity')
        self.includeQty.set_active(True)
        self.wantNotify = gtk.CheckButton('Notify enabled')
        self.wantNotify.set_active(False)
        self.saleQueries = gtk.CheckButton('Includes in "For sale" queries')
        self.saleQueries.set_active(True)
        self.partCondition = gtk.combo_box_new_text()
        self.partCondition.append_text('Don\'t care')
        self.partCondition.append_text('New parts')
        self.partCondition.append_text('Used parts')
        self.partCondition.set_active(0)
        self.fileOutput = gtk.Entry()
        self.fileOutput.set_editable(False)
        self.fileChoose = gtk.Button('Select output file...')
        self.fileChoose.connect('clicked',self.fileChooseCB)
        
        lab1 = gtk.Label('List ID (blank for "main"):')
        lab1.set_alignment(1,0.5)
        table.attach(lab1,0,1,0,1,xoptions=gtk.FILL)
        table.attach(self.listID,1,2,0,1,xpadding=3)
        lab2 = gtk.Label('Output file:')
        lab2.set_alignment(1,0.5)
        table.attach(lab2,0,1,1,2,xoptions=gtk.FILL)
        table.attach(self.fileOutput,1,3,1,2,xpadding=3)
        table.attach(self.fileChoose,3,4,1,2,xpadding=3)
        self.vBox.pack_start(table,False)        
        frame = gtk.Frame('Export options')
        table1 = gtk.Table(3,3)
        table1.attach(self.includeQty,0,1,0,1)
        table1.attach(self.wantNotify,0,1,1,2)
        table1.attach(self.saleQueries,0,1,2,3)
        lab3 = gtk.Label('Part must be:')
        lab3.set_alignment(1,0.5)
        table1.attach(lab3,1,2,0,1)
        table1.attach(self.partCondition,2,3,0,1,xpadding=3)
        frame.add(table1)
        self.vBox.pack_start(frame,False)
        self.vBox.show_all()
                             
        