'''
Created on 28/nov/2011

@author: mario
'''

import re
import gtk
import gobject

class BLPartSearch(gtk.Dialog):
    '''
    classdocs
    '''


    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
            pass

    def cursorChangedCB(self,widget):
        selPath = widget.get_cursor()[0]
        if selPath == None or self.imgCache == None:
            return
        selRow = self.reslist.get_iter(selPath)
        brickid = self.reslist.get(selRow,0)[0]
#        brickid = self.reslist.getPartBLID(selPath)
        brickFile = self.imgCache.brickImgBL(brickid)
        if brickFile == None:
            self.brickImage.clear()
            return
        #print brickFile
        if self.brickImage != None:
            r = self.brickImage.get_allocation()
            x = r.width
            y = x
            img = gtk.gdk.pixbuf_new_from_file(brickFile)
            img = img.scale_simple(x,y,gtk.gdk.INTERP_BILINEAR)
            self.brickImage.set_from_pixbuf(img)        

    def partSearchCB(self,widget,column):
        self.resview.set_search_column(column)
        
    def searchPartCB(self,widget):
        text = self.partDescr.get_text()
        partid = self.partID.get_text()
                
        self.reslist.clear()
        if len(partid) > 0:
            partid = partid + '%'
            #---------------------------------------- search by id (like match)
            c = self.catalog.getBLPartByID(partid)                
        elif len(text) > 0:
            #----------------------------------- search by generic text and year
            #text = '%' + text + '%'
            c = self.catalog.ftsBLPart(text)
        else:
            return
            
        for r in c:
            row = (r[0],r[1],r[2])
            self.reslist.append(row=row)


    def __init__(self,title="Search part in BL catalog", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT),catalog=None,imgCache=None):
        '''
        Constructor
        '''
        super(BLPartSearch, self).__init__(title=title,parent=parent,flags=flags,buttons=buttons)
        self.catalog = catalog
        self.imgCache = imgCache 
        
        self.connect('response',self.responseCB)
      
        #-------------------------------------------------------- primary layout
        self.vBox = self.get_content_area()
        self.partID = gtk.Entry()
        self.partDescr = gtk.Entry()
        self.search = gtk.Button('Start search...')
        self.search.connect('clicked',self.searchPartCB)
        self.reslist = gtk.ListStore(gobject.TYPE_STRING,
                                     gobject.TYPE_STRING,
                                     gobject.TYPE_STRING
                                     )
        
        self.resview = gtk.TreeView(self.reslist)
        
        self.crtPartID = gtk.CellRendererText()
        self.crtPartName = gtk.CellRendererText()
        self.crtPartYear = gtk.CellRendererText()
        self.crtPartCategory = gtk.CellRendererText()
        
        self.tvcPartID = gtk.TreeViewColumn('Part ID',self.crtPartID)
        self.tvcPartName = gtk.TreeViewColumn('Part Name ',self.crtPartName)
        self.tvcPartCategory = gtk.TreeViewColumn('Category',self.crtPartCategory)

        self.tvcPartID.set_resizable(True)
        self.tvcPartName.set_resizable(True)
        self.tvcPartCategory.set_resizable(True)
        
        self.tvcPartID.set_attributes(self.crtPartID,text=0)
        self.tvcPartName.set_attributes(self.crtPartName,text=1)
        self.tvcPartCategory.set_attributes(self.crtPartCategory,text=2)
        
        self.resview.append_column(self.tvcPartID)
        self.resview.append_column(self.tvcPartName)
        self.resview.append_column(self.tvcPartCategory)
        
        self.tvcPartID.set_sort_column_id(0)
        self.tvcPartID.connect('clicked',self.partSearchCB,0)
        self.tvcPartName.set_sort_column_id(1)
        self.tvcPartName.connect('clicked',self.partSearchCB,1)
        self.tvcPartCategory.set_sort_column_id(2)
        self.tvcPartCategory.connect('clicked',self.partSearchCB,2)
        
        sw = gtk.ScrolledWindow()
        sw.add(self.resview)
        
        self.vBox.pack_start(sw)
        sep = gtk.HSeparator()
        self.vBox.pack_start(sep,False,padding=3)
        
        ltable = gtk.Table(4,4)
        ltable.set_row_spacings(3)
        ltable.set_homogeneous(False)
        lab1 = gtk.Label('Part ID: ')
        lab1.set_alignment(1,0.5)
        ltable.attach(lab1,0,1,0,1,yoptions=gtk.SHRINK)
        ltable.attach(self.partID,1,2,0,1,xpadding=4,yoptions=gtk.SHRINK)
        lab2 = gtk.Label('Generic search\n(by name or category): ')
        lab2.set_alignment(1,0.5)
        ltable.attach(lab2,0,1,1,2,yoptions=gtk.SHRINK)
        ltable.attach(self.partDescr,1,2,1,2,xpadding=4,yoptions=gtk.SHRINK)
        self.brickImage = gtk.Image()
        frame = gtk.Frame('Brick shape')
        frame.set_border_width(3)
        self.brickImage.set_size_request(200,200)
        frame.add(self.brickImage)
        ltable.attach(frame,2,3,0,4,xoptions=gtk.SHRINK,yoptions=gtk.SHRINK)
        ltable.attach(self.search,0,2,2,3,yoptions=gtk.SHRINK)
        ltable.attach(gtk.Label(' '),0,2,3,4)
        
        self.resview.connect('cursor-changed',self.cursorChangedCB)
        
        self.vBox.pack_start(ltable,False)
        self.set_default_size(min(gtk.gdk.screen_width()-400,600),
                            min(gtk.gdk.screen_height()-400,500))

        
        self.vBox.show_all()        