'''
Created on 19/ott/2011

@author: mario
'''

import gtk
import gobject
from BrickUtils import BLPartSearch



class BrickEdit(gtk.Dialog):

    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
            #------------------------------------------------ save edits in part
            try:
                lddid = int(self.lddid.get_text())
            except ValueError:
                lddid = 0
            
            if lddid == 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                                message_format="LDD part ID must be an integer grater than 0.")
                msg.set_title('Wrong part ID')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            
            i = self.lddcolor.get_active_iter()
            if i != None:
                model = self.lddcolor.get_model()
                color,name,rgb = model.get(i,0,1,2)
            else:
                color,name,rgb = (0,'no match',None)
                
            bl = self.catalog.convertLDD2BL(lddid,color,self.decoratedBrick.get_active())
            
            self.part = ['P',
                            bl['blid'],
                            self.quantity.get_value_as_int(),
                            bl['blcolorid'],
                            False,
                            False,
                            self.descr.get_text(),
                            lddid,
                            rgb,
                            name,
                            bl['blrgb'],
                            bl['blcolorname'],
                            bl['blcategory'],
                            0,
                            color,
                            self.decoratedBrick.get_active(),
                            False
                            ]

    def addRepeatCB(self,widget):
        #------------------------------------------------ save edits in part
        try:
            lddid = int(self.lddid.get_text())
        except ValueError:
            lddid = 0
        
        if lddid == 0:
            msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                            message_format="LDD part ID must be an integer grater than 0.")
            msg.set_title('Wrong part ID')
            msg.run()
            msg.hide()
            msg.destroy()
            return
        
        i = self.lddcolor.get_active_iter()
        if i != None:
            model = self.lddcolor.get_model()
            color,name,rgb = model.get(i,0,1,2)
        else:
            color,name,rgb = (0,'no match',None)
            
        bl = self.catalog.convertLDD2BL(lddid,color,self.decoratedBrick.get_active())
        
        self.part = ['P',
                        bl['blid'],
                        self.quantity.get_value_as_int(),
                        bl['blcolorid'],
                        False,
                        False,
                        self.descr.get_text(),
                        lddid,
                        rgb,
                        name,
                        bl['blrgb'],
                        bl['blcolorname'],
                        bl['blcategory'],
                        0,
                        color,
                        self.decoratedBrick.get_active(),
                        False
                        ]
        self.part[13] = self.currList.getMaxPartID() + 1
        self.catalog.add2CurrList(self.part)
        self.catalog.commit()
        self.currList.read()
        #self.updateBrickList()
        #self.brickImage.clear()
        
        

    def setBrickColor(self,color):
        self.lddcolorid = color
        model = self.lddcolor.get_model()
        for r in model:
            if self.lddcolorid == model.get_value(r.iter,0):
                self.lddcolor.set_active_iter(r.iter)
                break        

    def searchCB(self,widget):
        dlg = BLPartSearch.BLPartSearch(parent=self,catalog=self.catalog,imgCache=self.imgCache)
        r = dlg.run()
        dlg.hide()
        if r == gtk.RESPONSE_ACCEPT:
            c = dlg.resview.get_cursor()[0]
            if c == None:
                return
            i = dlg.reslist.get_iter(c)
            blid = dlg.reslist.get(i,0)[0]
            descr = dlg.reslist.get(i,1)[0]
            p = self.catalog.partBl2Ldd(blid)
            if len(p) == 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                    message_format="No LDD part match with BrickLink code '"+blid+"'")
                msg.set_title('No matching LDD ID')
                msg.run()
                msg.hide()
                msg.destroy()                
                return
            else:
                self.lddid.set_text(str(p[0][0]))
                self.descr.set_text(descr)


    '''
    reads color list from table colormap in catalog
    @return: a gtk.ListStore
    '''
    def buildLDDcolorList(self):
        #------------------------------------------------- query color table
        c = self.catalog.getLDDColors()
        
        #------------------------------------ iterates through query results
        colorlist = gtk.ListStore(gobject.TYPE_INT,gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING)
        for r in c:
            color = r[2]
            colorlist.append(row=(r[0],r[1],color,r[2]))

        return colorlist

    def __init__(self,title="Edit Brick", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT),
                 catalog=None,currList=None,imgCache=None,editFlag=True):
        
        super(BrickEdit, self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        
        self.catalog = catalog
        self.imgCache = imgCache
        self.currList = currList
        self.part = []

        self.connect('response',self.responseCB)

        self.vBox = self.get_content_area()
        self.table = gtk.Table(5,3)
        
        self.lddcolorid = 0
        self.descr = gtk.Entry()
        self.lddid = gtk.Entry()
        self.adj = gtk.Adjustment(lower=0,upper=2000000000,step_incr=1,page_incr=50)
        self.quantity = gtk.SpinButton(adjustment=self.adj,digits=0)
        self.decoratedBrick = gtk.CheckButton('Decorated')
        
        colorlist = self.buildLDDcolorList()
        self.lddcolor = gtk.ComboBox(model=colorlist)
        col = gtk.CellRendererText()
        col.set_fixed_size(16,-1)
        bid = gtk.CellRendererText()
        name = gtk.CellRendererText()
        self.lddcolor.pack_start(bid,False)
        self.lddcolor.pack_start(col,False)
        self.lddcolor.pack_start(name,False)
        self.lddcolor.add_attribute(bid,'text',0)
        self.lddcolor.add_attribute(col,'background',2)
        self.lddcolor.add_attribute(name,'text',1)

        lab1 = gtk.Label('LDD Part ID:')
        lab1.set_alignment(1,0.5)
        lab2 = gtk.Label('Description:')
        lab2.set_alignment(1,0.5)
        lab3 = gtk.Label('Color (LDD):')
        lab3.set_alignment(1,0.5)
        lab4 = gtk.Label('Quantity:')
        lab4.set_alignment(1,0.5)
        self.searchButton = gtk.Button('Search...')
        self.searchButton.connect('clicked',self.searchCB)
        if not editFlag:
            self.repeatButton = gtk.Button('Add&Repeat')
            self.repeatButton.connect('clicked',self.addRepeatCB)
            self.table.attach(self.repeatButton,2,3,4,5)
        self.table.attach(lab1,0,1,0,1)
        self.table.attach(self.lddid,1,2,0,1)
        self.table.attach(self.searchButton,2,3,0,1,xoptions=gtk.SHRINK,yoptions=gtk.SHRINK)
        self.table.attach(lab2,0,1,1,2)
        self.table.attach(self.descr,1,3,1,2)
        self.table.attach(lab3,0,1,2,3)
        self.table.attach(self.lddcolor,1,2,2,3)
        self.table.attach(lab4,0,1,3,4)
        self.table.attach(self.quantity,1,2,3,4)
        self.table.attach(self.decoratedBrick,1,2,4,5)
        
        self.vBox.pack_start(self.table,False)
        self.vBox.show_all()