'''
Created on 25/feb/2012

@author: mario
'''

import os
import os.path
import httplib


class BrickImage(object):
    '''
    classdocs
    '''
    

    def brickImgLDD(self,lddid):
        ldr = self.catalog.partLdd2Ldraw(lddid)
        if len(ldr) == 1:
            return self.brickImageRetrieve(ldr[0][0].split('.')[0])
        return None

    def brickImgBL(self,blid):
        ldr = self.catalog.partBL2Ldraw(blid)
        if len(ldr) == 1:
            return self.brickImageRetrieve(ldr[0][0].split('.')[0])
        else:
            # try BL code == Ldraw code
            ldr = self.catalog.getLDrawPart(blid+'.dat')
            if len(ldr) == 1:
                return self.brickImageRetrieve(ldr[0][0].split('.')[0])
        return None
        
    def brickImgLdraw(self,ldrawid):
        return self.brickImageRetrieve(ldrawid.split('.')[0])


    def brickImageRetrieve(self,brickId):
        brickFile = os.path.join(self.storageDir,brickId+'.png')
        if not os.access(brickFile,os.F_OK):
            url = self.urlImages+brickId+'.png'
            try:
                conn = httplib.HTTPConnection(self.siteImages,timeout=4)
                conn.request("GET", url)
                r1 = conn.getresponse()
            except Exception:
                return None
            #print r1.status, r1.reason
            if r1.status != 200:
                return None
            bf = open(brickFile,'wb')
            while True:
                dati = r1.read(4096)
                if len(dati) == 0:
                    break
                bf.write(dati)
            bf.close()
            conn.close()
        return brickFile


    def __init__(self,imageStorage,catalog=None):
        '''
        Creates a class to handle all bricks images
        It is a directory inside BrickUtils work directory, that keeps all image files as a cache.
        if an image is not present, it is retrieved via HTTP GET from BrickLink website
        
        parms:
        imageStorage: path for image cache directory
        '''
        
        self.storageDir = imageStorage
        self.siteImages = 'ilpettegolo.altervista.org'
        self.urlImages = '/bricks/'
        self.catalog = catalog
