'''
Created on 16/set/2011

@author: mario
'''

'''
TODO


'''

import sqlite3
import gobject
import gtk


#------------------------------------ defining indices for data in row tuple
ids = {'type':0,
       'blid':1,
       'qty':2,
       'blcolorid':3,
       'extra':4,
       'counterpart':5,
       'descr':6,
       'lddid':7,
       'lddrgb':8,
       'lddcolorname':9,
       'blrgb':10,
       'blcolorname':11,
       'blcategory':12,
       'partid':13,
       'lddcolorid':14,
       'decorated':15,
       'altern':16
       }



def getIndex():
    global ids
    return ids



class BrickListStore(gtk.ListStore):
    '''
    Class to handle a list of bricks and parts, ready for display in a TreeView
    Made for hiding most part of index dependency for rows in list
    '''

      
    '''
    retuns partid from list
    '''
    def getPartID(self,path):
        global ids
        selRow = self.get_iter(path)
        return self.get(selRow,ids['partid'])[0]
  
    def getPartBLID(self,path):
        global ids
        selRow = self.get_iter(path)
        return self.get(selRow,ids['blid'])[0]
    
    def getPartLDDID(self,path):
        global ids
        selRow = self.get_iter(path)
        return self.get(selRow,ids['lddid'])[0]

    def isCounterpart(self,iterator):
        global ids
        return self.get(iterator,ids['counterpart'])[0]

    def isExtra(self,iterator):
        global ids
        return self.get(iterator,ids['extra'])[0]

    def removePath(self,path):
        if path == None:
            return
        selRow = self.get_iter(path)
        super(BrickListStore,self).remove(selRow)

    def removeParts(self,partlist):
        global ids
        rlist = []
        for row in self:
            if row[ids['partid']] in partlist:
                rlist.append(row[ids['partid']])
                self.remove(row.iter)
        return rlist
    
    def getMaxPartID(self):
        return self.maxPartID

    '''
    removes 'counterpart' parts from list
    @return: a list of part id removed
    '''    
    def removeCounterparts(self):
        global ids
        rlist = []
        for row in self:
            if row[ids['counterpart']]:
                rlist.append(row[ids['partid']])
                self.removePath(row.path)
        return rlist

    '''
    removes 'extra' parts from list
    @return: a list of part id removed
    '''    
    def removeExtra(self):
        global ids
        rlist = []
        for row in self:
            if row[ids['extra']]:
                rlist.append(row[ids['partid']])
                self.removePath(row.path)
        return rlist


    def read(self):
        '''
        reads "current" brick list from db
        '''
        
        self.clear()
        
        try:
            c = self.catalog.readCurrList()
        except sqlite3.OperationalError:
            return
        self.maxPartID = 0
        for r in c:
            self.append(row=(r['type'],
                             r['blid'],
                             r['qty'],
                             str(r['blcolorid']),
                             r['extra'],
                             r['counterpart'],
                             r['descr'],
                             str(r['lddid']),
                             r['lddrgb'],
                             r['lddcolorname'],
                             r['blrgb'],
                             r['blcolorname'],
                             r['blcategory'],
                             r['partid'],
                             r['lddcolorid'],
                             r['decorated'],
                             r['altern']
                             ))
            if r['partid'] > self.maxPartID:
                self.maxPartID = r['partid']
                      
        return                
    
    def write(self):
        '''
        writes a dictionary as a brick list in a table on database
        '''
        
        self.catalog.cleanCurrList()
        
        self.maxPartID = 0
        for r in self:
            self.catalog.add2CurrList(r)
            if r[13] > self.maxPartID:
                self.maxPartID = r[13]
        self.catalog.commit()

    def __init__(self,catalog=None):
        '''
        Constructor 
        '''
        super(BrickListStore,self).__init__(gobject.TYPE_STRING,      # part type
                                      gobject.TYPE_STRING,      # BL ID
                                      gobject.TYPE_INT,         # quantity
                                      gobject.TYPE_STRING,         # BL color ID
                                      gobject.TYPE_BOOLEAN,     # extra part?
                                      gobject.TYPE_BOOLEAN,     # is a counterpart?
                                      gobject.TYPE_STRING,      # description
                                      gobject.TYPE_STRING,         # LDD ID
                                      gobject.TYPE_STRING,      # LDD color rgb
                                      gobject.TYPE_STRING,      # LDD color name
                                      gobject.TYPE_STRING,      # BL color rgb
                                      gobject.TYPE_STRING,      # BL color name
                                      gobject.TYPE_INT,         # BL category
                                      gobject.TYPE_INT,         # unique id
                                      gobject.TYPE_INT,         # LDD color ID
                                      gobject.TYPE_BOOLEAN,     # is decorated?
                                      gobject.TYPE_BOOLEAN      # has alternate part?
                                      )
        self.catalog = catalog
        self.maxPartID = 0
        