'''
Created on 16/set/2011

@author: mario
'''

import gtk
import BrickListStore



class BrickListView(gtk.TreeView):
    '''
    classdocs
    '''

    def setSearchCB(self,widget,column):
        self.set_search_column(column)


    def cursorChangedCB(self,widget):
        selPath = widget.get_cursor()[0]
        if selPath == None or self.imgCache == None:
            return
        m = self.get_model()
        brickid = m.getPartLDDID(selPath)
        if brickid != '-':
            brickFile = self.imgCache.brickImgLDD(brickid)
        else:
            brickid = m.getPartBLID(selPath)
            p = brickid.split('.')
            if len(p) > 1:
                brickFile = self.imgCache.brickImgLdraw(brickid)
            else:
                brickFile = self.imgCache.brickImgBL(brickid)
        if brickFile == None:
            self.widget.clear()
            return
        #print brickFile
        if self.widget != None:
            r = self.widget.get_allocation()
            x = r.width
            y = x
            img = gtk.gdk.pixbuf_new_from_file(brickFile)
            img = img.scale_simple(x,y,gtk.gdk.INTERP_BILINEAR)
            self.widget.set_from_pixbuf(img)


    def __init__(self,listStore,imgCache=None,widget=None):
        '''
        Constructor
        '''
        
        super(BrickListView,self).__init__(listStore)
        
        self.imgCache = imgCache
        self.widget = widget
        
        idx = BrickListStore.getIndex()
        
        self.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_HORIZONTAL)

        #---------------------- column and cell renderer definition for treeview
        self.crtID = gtk.CellRendererText()
        self.tvcID = gtk.TreeViewColumn('ID',self.crtID)
        self.tvcID.set_resizable(True)
        
        self.crtBLID = gtk.CellRendererText()
        self.tvcBLID = gtk.TreeViewColumn('BLink ID',self.crtBLID)
        self.tvcBLID.set_resizable(True)

        self.crtLDDID = gtk.CellRendererText()
        self.tvcLDDID = gtk.TreeViewColumn('LDD ID',self.crtLDDID)
        self.tvcLDDID.set_resizable(True)

        self.crtLDDColorID = gtk.CellRendererText()
        self.crtLDDColor = gtk.CellRendererText()
        self.crtLDDColor.set_fixed_size(16,-1)
        self.crtLDDColorName = gtk.CellRendererText()
        self.tvcLDDColor = gtk.TreeViewColumn('LDD Color')
        self.tvcLDDColor.pack_start(self.crtLDDColorID,False)
        self.tvcLDDColor.pack_start(self.crtLDDColor,False)
        self.tvcLDDColor.pack_start(self.crtLDDColorName,True)
        self.tvcLDDColor.set_resizable(True)
        
        self.crtBLColorID = gtk.CellRendererText()
        self.crtBLColor = gtk.CellRendererText()
        self.crtBLColor.set_fixed_size(16,-1)
        self.crtBLColorName = gtk.CellRendererText()
        self.tvcBLColor = gtk.TreeViewColumn('BLink Color')
        self.tvcBLColor.pack_start(self.crtBLColorID,False)
        self.tvcBLColor.pack_start(self.crtBLColor,False)
        self.tvcBLColor.pack_start(self.crtBLColorName,True)
        self.tvcBLColor.set_resizable(True)
        
        self.crtQty = gtk.CellRendererText()
        self.tvcQty = gtk.TreeViewColumn('Qty',self.crtQty)
        self.tvcQty.set_resizable(True)

        self.crtDescr = gtk.CellRendererText()
        self.tvcDescr = gtk.TreeViewColumn('Part description',self.crtDescr)
        self.tvcDescr.set_resizable(True)

        
        self.crtgDecor = gtk.CellRendererToggle()
        self.tvcDecor = gtk.TreeViewColumn('Decor',self.crtgDecor)
        self.tvcDecor.set_resizable(True)

        self.crtgExtra = gtk.CellRendererToggle()
        self.tvcExtra = gtk.TreeViewColumn('Extra',self.crtgExtra)
        self.tvcExtra.set_resizable(True)

        self.crtgAlternate = gtk.CellRendererToggle()
        self.tvcAlternate = gtk.TreeViewColumn('Altern',self.crtgAlternate)
        self.tvcAlternate.set_resizable(True)

        self.crtgCounterpart = gtk.CellRendererToggle()
        self.tvcCounterpart = gtk.TreeViewColumn('Cnterp',self.crtgCounterpart)
        self.tvcCounterpart.set_resizable(True)

        self.append_column(self.tvcID)
        self.append_column(self.tvcBLID)
        self.append_column(self.tvcLDDID)
        self.append_column(self.tvcLDDColor)
        self.append_column(self.tvcBLColor)
        self.append_column(self.tvcQty)
        self.append_column(self.tvcDescr)
        self.append_column(self.tvcDecor)
        self.append_column(self.tvcExtra)
        self.append_column(self.tvcAlternate)
        self.append_column(self.tvcCounterpart)
        self.set_expander_column(self.tvcDescr)
        self.tvcID.set_attributes(self.crtID,text=idx['partid'])
        self.tvcBLID.set_attributes(self.crtBLID,text=idx['blid'])
        self.tvcLDDID.set_attributes(self.crtLDDID,text=idx['lddid'])
        self.tvcLDDColor.set_attributes(self.crtLDDColorID,text=idx['lddcolorid'])
        self.tvcLDDColor.set_attributes(self.crtLDDColor,cell_background=idx['lddrgb'])
        self.tvcLDDColor.set_attributes(self.crtLDDColorName,text=idx['lddcolorname'])
        self.tvcBLColor.set_attributes(self.crtBLColorID,text=idx['blcolorid'])
        self.tvcBLColor.set_attributes(self.crtBLColor,cell_background=idx['blrgb'])
        self.tvcBLColor.set_attributes(self.crtBLColorName,text=idx['blcolorname'])
        self.tvcQty.set_attributes(self.crtQty,text=idx['qty'])
        self.tvcDescr.set_attributes(self.crtDescr,text=idx['descr'])
        self.tvcDecor.set_attributes(self.crtgDecor,active=idx['decorated'])
        self.tvcExtra.set_attributes(self.crtgExtra,active=idx['extra'])
        self.tvcAlternate.set_attributes(self.crtgAlternate,active=idx['altern'])
        self.tvcCounterpart.set_attributes(self.crtgCounterpart,active=idx['counterpart'])

        self.tvcDecor.set_sort_column_id(idx['decorated'])
        self.tvcExtra.set_sort_column_id(idx['extra'])
        self.tvcID.set_sort_column_id(idx['partid'])
        self.tvcAlternate.set_sort_column_id(idx['altern'])
        self.tvcCounterpart.set_sort_column_id(idx['counterpart'])
        self.tvcBLID.set_sort_column_id(idx['blid'])
        self.tvcBLID.connect('clicked',self.setSearchCB,idx['blid'])
        self.tvcLDDID.set_sort_column_id(idx['lddid'])
        self.tvcLDDID.connect('clicked',self.setSearchCB,idx['lddid'])
        self.tvcQty.set_sort_column_id(idx['qty'])
        self.tvcQty.connect('clicked',self.setSearchCB,idx['qty'])
        self.tvcDescr.set_sort_column_id(idx['descr'])
        self.tvcDescr.connect('clicked',self.setSearchCB,idx['descr'])
        
        #----------------------------------- small image retrieve (experimental)
        self.connect('cursor-changed',self.cursorChangedCB)
        