'''
Created on 22/set/2011

@author: mario
'''

import gtk
import gobject


idx = {'rowid':0,
       'lddid':1,
       'lddcolorid':2,
       'decorated':3,
       'descr':4,
       'qty':5
       }


class CatalogStore(gtk.ListStore):
    '''
    classdocs
    '''

    def getPartID(self,path):
        global idx
        selRow = self.get_iter(path)
        return self.get(selRow,idx['lddid'])[0]
    
    def getPartBLID(self,path):
        global idx
        selRow = self.get_iter(path)
        lddid = self.get(selRow,idx['lddid'])[0]
        p = self.catalog.partLdd2Bl(lddid)
        if len(p) == 0:
            return 0
        else:
            return p[0][0]
    

    def read(self):
        '''
        reads the brick catalog
        '''
        
        if self.catalog == None:
            return
        self.clear()
        c = self.catalog.getCatalog()
        
        for r in c:
            self.append(row=(r['rowid'],    
                             r['partid'],  
                             r['colorid'],
                             r['decorated'],
                             r['descr'],
                             r['qty'],
                             r['lddname'],
                             r['rgb'] if r['rgb'] != None else '#fff'
                                   ))
                      

    def write(self):
        '''
        write down brick catalog on database
        '''
        global idx
        
        if self.catalog == None:
            return
        # re-create table with import list
        self.catalog.cleanCatalog()
        
        for r in self:
            d = dict(zip(idx,r))
            self.catalog.insert2Catalog(d['rowid'],
                                        d['lddid'],
                                        d['lddcolorid'],
                                        d['decorated'],
                                        d['descr'],
                                        d['qty']
                                        )
        self.catalog.commit()
            

    def __init__(self,catalog=None):
        '''
        Constructor
        '''
        super(CatalogStore,self).__init__(gobject.TYPE_INT,     # item id
                                          gobject.TYPE_INT,     # ldd part id
                                          gobject.TYPE_INT,     # ldd color id
                                          gobject.TYPE_BOOLEAN, # decorated
                                          gobject.TYPE_STRING,  # description
                                          gobject.TYPE_INT,     # quantity
                                          gobject.TYPE_STRING,  # color name
                                          gobject.TYPE_STRING   # hex rgb Color
                                          )
        self.catalog = catalog
        if self.catalog != None:
            self.read()

