'''
Created on 22/set/2011

@author: mario
'''

import gtk
import re

class CatalogView(gtk.TreeView):
    '''
    classdocs
    '''

    def setSearchCB(self,widget,column):
        self.set_search_column(column)

    def cursorChangedCB(self,widget):
        selPath = widget.get_cursor()[0]
        if selPath == None or self.imgCache == None:
            return
        m = self.get_model()
        brickid = m.getPartID(selPath)
        brickFile = self.imgCache.brickImgLDD(brickid)
        if brickFile == None:
            self.widget.clear()
            return
        #print brickFile
        if self.widget != None:
            r = self.widget.get_allocation()
            x = r.width
            y = x
            img = gtk.gdk.pixbuf_new_from_file(brickFile)
            img = img.scale_simple(x,y,gtk.gdk.INTERP_BILINEAR)
            self.widget.set_from_pixbuf(img)


    def __init__(self,catalogStore,imgCache=None,widget=None):
        '''
        Constructor
        '''
        super(CatalogView,self).__init__(catalogStore)
        
        self.imgCache = imgCache
        self.widget = widget

        self.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_HORIZONTAL)

        #---------------------- column and cell renderer definition for treeview
        self.crtID = gtk.CellRendererText()
        self.tvcID = gtk.TreeViewColumn('ID',self.crtID)
        self.tvcID.set_resizable(True)        
        
        self.crtLDDID = gtk.CellRendererText()
        self.tvcLDDID = gtk.TreeViewColumn('LDD ID',self.crtLDDID)
        self.tvcLDDID.set_resizable(True)

        self.crtLDDColorID = gtk.CellRendererText()
        self.crtLDDColorID.set_property('xalign',1)
        self.crtLDDColor = gtk.CellRendererText()
        self.crtLDDColor.set_fixed_size(16,-1)
        self.crtLDDColorName = gtk.CellRendererText()
        self.tvcLDDColor = gtk.TreeViewColumn('LDD Color')
        self.tvcLDDColor.pack_start(self.crtLDDColorID,False)
        self.tvcLDDColor.pack_start(self.crtLDDColor,False)
        self.tvcLDDColor.pack_start(self.crtLDDColorName,True)
        self.tvcLDDColor.set_resizable(True)

        self.crtQty = gtk.CellRendererText()
        self.tvcQty = gtk.TreeViewColumn('Qty',self.crtQty)
        self.tvcQty.set_resizable(True)

        self.crtDescr = gtk.CellRendererText()
        self.tvcDescr = gtk.TreeViewColumn('Part description',self.crtDescr)
        self.tvcDescr.set_resizable(True)

        self.crtgDecor = gtk.CellRendererToggle()
        self.tvcDecor = gtk.TreeViewColumn('Decor',self.crtgDecor)
        self.tvcDecor.set_resizable(True)

        self.append_column(self.tvcID)
        self.append_column(self.tvcLDDID)
        self.append_column(self.tvcLDDColor)
        self.append_column(self.tvcDecor)                        
        self.append_column(self.tvcQty)
        self.append_column(self.tvcDescr)

        self.tvcID.set_attributes(self.crtID,text=0)
        self.tvcLDDID.set_attributes(self.crtLDDID,text=1)
        self.tvcLDDColor.set_attributes(self.crtLDDColorID,text=2)
        self.tvcLDDColor.set_attributes(self.crtLDDColor,cell_background=7)
        self.tvcLDDColor.set_attributes(self.crtLDDColorName,text=6)
        self.tvcDecor.set_attributes(self.crtgDecor,active=3)
        self.tvcQty.set_attributes(self.crtQty,text=5)
        self.tvcDescr.set_attributes(self.crtDescr,text=4)
        
        self.tvcID.set_sort_column_id(0)
        self.tvcLDDID.set_sort_column_id(1)
        self.tvcLDDID.connect('clicked',self.setSearchCB,1)
        self.tvcQty.set_sort_column_id(5)
        self.tvcQty.connect('clicked',self.setSearchCB,5)
        self.tvcDescr.set_sort_column_id(4)
        self.tvcDescr.connect('clicked',self.setSearchCB,4)
        self.tvcLDDColor.set_sort_column_id(2)
        self.tvcLDDColor.connect('clicked',self.setSearchCB,6)
        
        self.connect('cursor-changed',self.cursorChangedCB)
        
        
