'''
Created on 21/ott/2011

@author: mario
'''

import re
import gtk
import CatalogStore
import CatalogView
from BrickListStore import BrickListStore
from BLExportXML import BLExportXML
from ExportHTML import ExportHTML
from BrickException import BrickException


class CheckBuildable(gtk.Dialog):
    '''
    classdocs
    '''
    
    '''
    use selected brick from lower window as replacement.
    computes quantity and track if replacement bricks are less than needed
    '''
    def useSelectedAsAlternateCB(self,widget):
        altPath = self.altView.get_cursor()[0]
        if altPath == None:
            return
        selPath = self.neededView.get_cursor()[0]
        if selPath == None:
            return
        altBrick = self.altList[altPath]
        if altBrick[1] == 0:
            #------------------------------- "no parts" message selected, ignore
            return
        needBrick = self.neededList[selPath]
        
        for blBrick in self.brickList:
            if needBrick[0] == blBrick[13]:
                break
        else:
            raise BrickException("Internal error: Brick not found in current brick list when select alternate part")
        blPath = blBrick.path
        clBrick = self.catalog.convertLDD2BL(altBrick[1],altBrick[2],altBrick[3])
        if needBrick[5] <= altBrick[5]:
            #---------------------- we have enough bricks of same type and color
            #------------------------ so, we change needed bricks with alternate
            listedBrick = self.catalog.searchCurrBrick(altBrick[1],altBrick[2],altBrick[3])
            if blBrick[2] == needBrick[5]:
                if listedBrick == None:
                    #------------------------------- no identical brick in curr list
                    row = (blBrick[0],
                           clBrick['blid'],
                           needBrick[5],
                           clBrick['blcolorid'],
                           False,
                           False,
                           clBrick['descr'],
                           clBrick['lddid'],
                           clBrick['lddrgb'],
                           clBrick['lddcolorname'],
                           clBrick['blrgb'],
                           clBrick['blcolorname'],
                           clBrick['blcategory'],
                           blBrick[13],
                           clBrick['lddcolorid'],
                           clBrick['decorated'],
                           False
                           )
                    self.brickList[blPath] = row
                else:
                    #----------------- add bricks to existing part in current bricks
                    for d in self.brickList:
                        if d[13] == listedBrick[13]:
                            row = (d[0],
                                   d[1],
                                   d[2] + needBrick[5],
                                   d[3],
                                   d[4],
                                   d[5],
                                   d[6],
                                   d[7],
                                   d[8],
                                   d[9],
                                   d[10],
                                   d[11],
                                   d[12],
                                   d[13],
                                   d[14],
                                   d[15],
                                   d[16]
                                   )
                            #----------------------------- removes old missing brick
                            break
                    else:
                        raise BrickException('Internal error: missing brick in current list when adding quantity')
                    self.brickList[d.path] = row
                    self.brickList.removePath(blPath)
            else:
                if listedBrick == None:
                    #------------------------------- no identical brick in curr list
                    row = (blBrick[0],
                           clBrick['blid'],
                           needBrick[5],
                           clBrick['blcolorid'],
                           False,
                           False,
                           clBrick['descr'],
                           clBrick['lddid'],
                           clBrick['lddrgb'],
                           clBrick['lddcolorname'],
                           clBrick['blrgb'],
                           clBrick['blcolorname'],
                           clBrick['blcategory'],
                           self.brickList.getMaxPartID()+1,
                           clBrick['lddcolorid'],
                           clBrick['decorated'],
                           False
                           )
                    self.brickList.append(row=row)
                else:
                    for d in self.brickList:
                        if d[13] == listedBrick[13]:
                            row = (d[0],
                                   d[1],
                                   d[2] + needBrick[5],
                                   d[3],
                                   d[4],
                                   d[5],
                                   d[6],
                                   d[7],
                                   d[8],
                                   d[9],
                                   d[10],
                                   d[11],
                                   d[12],
                                   d[13],
                                   d[14],
                                   d[15],
                                   d[16]
                                   )
                            #----------------------------- removes old missing brick
                            break
                    else:
                        raise BrickException('Internal error: missing brick in current list when adding quantity')
                    self.brickList[d.path] = row                    
                self.brickList[blPath] = (blBrick[0],
                                          blBrick[1],
                                          blBrick[2] - needBrick[5],
                                          blBrick[3],
                                          blBrick[4],
                                          blBrick[5],
                                          blBrick[6],
                                          blBrick[7],
                                          blBrick[8],
                                          blBrick[9],
                                          blBrick[10],
                                          blBrick[11],
                                          blBrick[12],
                                          blBrick[13],
                                          blBrick[14],
                                          blBrick[15],
                                          blBrick[16]
                                          )
            self.brickList.write()
            self.listMissingBrick()
            self.altList.clear()
        else:
            #-------------------------------------------- we have less bricks...
            #------- so, we subtract the quantity and add a new brick definition
            #--------- checking if there is already a brick of same type in list
            listedBrick = self.catalog.searchCurrBrick(altBrick[1],altBrick[2],altBrick[3])
            if listedBrick == None:
                partid = self.brickList.getMaxPartID() + 1
                row = (blBrick[0],
                       clBrick['blid'],
                       altBrick[5],     # we take what we have...
                       clBrick['blcolorid'],
                       False,
                       False,
                       clBrick['descr'],
                       clBrick['lddid'],
                       clBrick['lddrgb'],
                       clBrick['lddcolorname'],
                       clBrick['blrgb'],
                       clBrick['blcolorname'],
                       clBrick['blcategory'],
                       partid,
                       clBrick['lddcolorid'],
                       clBrick['decorated'],
                       False
                       )
                self.brickList.append(row=row)
            else:
                for d in self.brickList:
                    if d[13] == listedBrick[13]:
                        row = (d[0],
                               d[1],
                               d[2] + altBrick[5],
                               d[3],
                               d[4],
                               d[5],
                               d[6],
                               d[7],
                               d[8],
                               d[9],
                               d[10],
                               d[11],
                               d[12],
                               d[13],
                               d[14],
                               d[15],
                               d[16]
                               )
                        break
                else:
                    raise BrickException('Internal error: missing brick in current list when adding quantity')
                self.brickList[d.path] = row
            self.brickList[blPath] = (blBrick[0],
                                      blBrick[1],
                                      blBrick[2] - altBrick[5],
                                      blBrick[3],
                                      blBrick[4],
                                      blBrick[5],
                                      blBrick[6],
                                      blBrick[7],
                                      blBrick[8],
                                      blBrick[9],
                                      blBrick[10],
                                      blBrick[11],
                                      blBrick[12],
                                      blBrick[13],
                                      blBrick[14],
                                      blBrick[15],
                                      blBrick[16]
                                      )    
            self.brickList.write()
            self.listMissingBrick()
            self.altList.clear()
                
    
    '''
    search for bricks in same category
    to be used when no bricks with same part ID are found in catalog
    '''
    def searchSameBLCategoryCB(self,widget):
        selPath = self.neededView.get_cursor()[0]
        if selPath == None:
            return
        widget.set_label('Searching...')
        while gtk.events_pending():
            gtk.main_iteration(block=False)
        lddid = self.neededList[selPath][1]
        p = self.catalog.findAltByCategory(lddid)
        self.altList.clear()
        if len(p) == 0:
            self.altList.append(row=(0,0,0,False,'No part available, sorry',0,'','#fff'))
        else:
            for b in p:
                self.altList.append(row=(b[0],
                                    b[1],
                                    b[2],
                                    b[3],
                                    b[4],
                                    b[5],
                                    b[6],
                                    b[7]
                                    ))
        widget.set_label('Find by category')


    def showAlternateCB(self,widget):
        selPath = widget.get_cursor()[0]
        if selPath == None:
            return
        lddid = self.altList.getPartID(selPath)
        if lddid == 0:
            return
        brickFile = self.imgCache.brickImgLDD(lddid)
        if brickFile == None:
            self.altImage.clear()
            return
        #print brickFile
        if self.altImage != None:
            r = self.altImage.get_allocation()
            x = r.width
            y = x
            img = gtk.gdk.pixbuf_new_from_file(brickFile)
            img = img.scale_simple(x,y,gtk.gdk.INTERP_BILINEAR)
            self.altImage.set_from_pixbuf(img)
        

    def findAlternateCB(self,widget):
        selPath = widget.get_cursor()[0]
        if selPath == None:
            return
        lddid = self.neededList[selPath][1]
        brickFile = self.imgCache.brickImgLDD(lddid)
        if brickFile == None:
            self.needImage.clear()
        else:            
            if self.needImage != None:
                r = self.needImage.get_allocation()
                x = r.width
                y = x
                img = gtk.gdk.pixbuf_new_from_file(brickFile)
                img = img.scale_simple(x,y,gtk.gdk.INTERP_BILINEAR)
                self.needImage.set_from_pixbuf(img)        
        a = self.catalog.findAltPart(lddid)
        self.altList.clear()
        self.altImage.clear()
        if len(a) == 0:
            self.altList.append(row=(0,0,0,False,'No part available, sorry',0,'','#fff'))
        else:
            for b in a:
                self.altList.append(row=(b[0],
                                    b[1],
                                    b[2],
                                    b[3],
                                    b[4],
                                    b[5],
                                    b[6],
                                    b[7]
                                    ))

    def listMissingBrick(self):
        c = self.catalog.checkIfBuildable()
        self.neededList.clear()
        for r in c:
            #------------------ checks if lddid is numeric, i.e. is a valid part
            try:
                lddid = int(r[1])
            except ValueError:
                lddid = 0
#            if lddid == 0:
#                continue
            self.neededList.append(row=(r[0],   # rowid
                                        lddid,   # lddid
                                        r[2],   # lddcolorid
                                        r[3],   # decorated
                                        r[4],   # descr
                                        r[5],   # qty
                                        r[6],   # ldd color name
                                        r[7]   # hex rgb
                                        ))
        try:
            bPerc = int((len(self.brickList) - len(self.neededList)) * 100 / len(self.brickList))
        except (ValueError,ArithmeticError):
            bPerc = 0
        c = 'black'
        if bPerc < 60:
            c = 'red'
        elif bPerc < 80:
            c = 'darkgreen'
        elif bPerc < 95:
            c = 'blue'
        self.labBuildPerc.set_markup('<span size="large" weight="bold" foreground="'+
                                     c+'">Percent buildable: '+str(bPerc)+'%</span>')
        

    def exportBLXMLCB(self,widget,catalog,missingList,exportType):
        # build part list from "missing"
        partList = BrickListStore()
        for p in missingList:
            bl = self.catalog.convertLDD2BL(p[1],p[2],p[3])
            partList.append(row=('P',      # type
                                bl['blid'],           # blpartid
                                p[5],            # qty
                                bl['blcolorid'],      # blcolorid
                                False,          # no extraPart
                                False,          # no counterpart
                                bl['descr'],          # description (from BL)
                                p[1],          # LDD part id
                                bl['lddrgb'],   # rgb color from LDD
                                bl['lddcolorname'],   # color name from LDD
                                bl['blrgb'],    # rgb color from BL
                                bl['blcolorname'],    # name from BL
                                bl['blcategory'],     # category in BLparts
                                p[0],         # unique ID for part
                                p[2],       # ldd color ID
                                p[3],      # decorated part?
                                False           # no alternate parts in LDD)
                                ))
        if exportType == 0:
            dlg = ExportHTML(parent=self,flags=gtk.DIALOG_MODAL,currList=partList,
                         catalog=catalog,imageCache=self.imgCache)
        elif exportType == 1:
            dlg = BLExportXML(parent=self,flags=gtk.DIALOG_MODAL,currList=partList,catalog=catalog)
        else:
            return
        dlg.run()
        dlg.hide()
        

    def __init__(self,title="Check if Buildable", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CLOSE,gtk.RESPONSE_ACCEPT),
                 catalog=None,brickList=None,imgCache=None):
        '''
        Constructor
        '''
        super(CheckBuildable, self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        self.catalog = catalog
        self.brickList = brickList
        self.imgCache = imgCache
        
        self.neededList = CatalogStore.CatalogStore()
        self.table = gtk.Table(2,2)
        self.table.set_row_spacings(3)
        self.labBuildPerc = gtk.Label(' ')
        self.listMissingBrick()
        self.neededView = CatalogView.CatalogView(self.neededList)
        self.neededView.tvcQty.set_title('Needed')
        self.neededView.connect('cursor-changed',self.findAlternateCB)
        self.vPaned = gtk.VPaned()
        self.vBox = self.get_content_area()
        self.sWindow = gtk.ScrolledWindow()
        self.sWindow.set_border_width(3)
        self.sWindow.add(self.neededView)
#        self.vBox.pack_start(self.vPaned)
        #------------------------------------------------ alternative parts list
        self.altWindow = gtk.ScrolledWindow()
        self.altWindow.set_border_width(3)
        self.altList = CatalogStore.CatalogStore()
        self.altView = CatalogView.CatalogView(self.altList)
        self.altView.tvcQty.set_title('Owned')
        self.altView.connect('cursor-changed',self.showAlternateCB)
        self.altWindow.add(self.altView)
        self.frame1 = gtk.Frame('Missing bricks')
        self.hbox1 = gtk.HBox()
        self.hbox1.set_spacing(3)
        self.frame2 = gtk.Frame('Possible substitution')
        self.frame1.set_border_width(3)
        self.frame2.set_border_width(3)
        self.frame1.add(self.sWindow)
        self.frame2.add(self.altWindow)
        self.vPaned.pack1(self.frame1,resize=True)
        self.vPaned.pack2(self.frame2)
        self.table.attach(self.vPaned,0,1,0,2)
        self.needImage = gtk.Image()
        frame = gtk.Frame('Needed brick shape')
        frame.set_border_width(3)
        self.needImage.set_size_request(200,200)
        frame.add(self.needImage)
        self.table.attach(frame,1,2,0,1,xoptions=gtk.SHRINK,yoptions=gtk.SHRINK)
        self.altImage = gtk.Image()
        frame = gtk.Frame('Alternate brick shape')
        frame.set_border_width(3)
        self.altImage.set_size_request(200,200)
        frame.add(self.altImage)
        self.table.attach(frame,1,2,1,2,xoptions=gtk.SHRINK,yoptions=gtk.SHRINK)
        self.set_default_size(min(gtk.gdk.screen_width()-400,800),
                              min(gtk.gdk.screen_height()-300,700))
        self.useSelectedAsAlternate = gtk.Button('Use as replacement')
        self.useSelectedAsAlternate.connect('clicked',self.useSelectedAsAlternateCB)
        self.searchSameBLCategory = gtk.Button('Find by category')
        self.searchSameBLCategory.connect('clicked',self.searchSameBLCategoryCB)
        self.exportHTML = gtk.Button('Exports missing as HTML')
        self.exportHTML.connect('clicked',self.exportBLXMLCB,self.catalog,self.neededList,0)
        self.exportBLXML = gtk.Button('Exports missing as BL XML')
        self.exportBLXML.connect('clicked',self.exportBLXMLCB,self.catalog,self.neededList,1)
        self.hBBox = gtk.HButtonBox()
        self.hBBox.set_layout(gtk.BUTTONBOX_START)
        self.hBBox.pack_start(self.useSelectedAsAlternate,False,False)
        self.hBBox.pack_start(self.searchSameBLCategory,False,False)
        self.hBBox.pack_start(self.exportHTML,False,False)
        self.hBBox.pack_start(self.exportBLXML,False,False)
        self.vBox.pack_start(self.table,True)
        self.vBox.pack_start(self.hBBox,False)
#        self.labBuildPerc.set_alignment(0,0.5)
        self.vBox.pack_start(self.labBuildPerc,False,padding=4)
        self.vBox.show_all()
        
        # query per elencare mattoncini dello stesso part ID ma con colori differenti, escludendo quelli gia' usari
        # select c.lddcolorid,c.decorated,coalesce((c.qty-b.qty),c.qty) as remain from catalog c left outer join bricklist b using(lddid,lddcolorid) where  lddid=3023;
        
        