'''
Created on 17/ago/2012

@author: mario
'''



import httplib
import xml.dom.minidom
import xml.parsers.expat
import hashlib
import os
import gtk

from ProgressDialog import ProgressDialog
from BrickUtils import progInfo


DEBUG = False


class DBUpdate(object):
    '''
    Database update functions:
    - checks for updates on web
    - get updates
    - apply updates
    '''

    __dbfile = '/butils/catalog.new'
    __xmlfile = '/butils/catalog.xml'


    def __init__(self,updateFile,webSite,dbversion):
        '''
        Constructor
        '''
        self.updateFile = updateFile
        self.webSite = webSite
        self.dbversion = dbversion
        
    def CheckDB(self):
        try:
            conn = httplib.HTTPConnection(self.webSite,timeout=4)
            conn.request("GET", self.__xmlfile)
            r1 = conn.getresponse()
        except Exception:
            return 0
        if DEBUG: 
            print r1.status, r1.reason
        if r1.status != 200:
            return 0
        bf = ''
        while True:
            dati = r1.read(4096)
            if len(dati) == 0:
                break
            bf = bf + dati
        conn.close()
        try :
            dbxml = xml.dom.minidom.parseString(bf)
        except xml.parsers.expat.ExpatError:
            return 0
        e = dbxml.getElementsByTagName('dbver')[0]
        if e == None:
            return 0
        if DEBUG: 
            print e.childNodes
        try:
            self.newDb = int(e.childNodes[0].data)
        except ValueError:
            self.newDb = 0
        if DEBUG: 
            print self.newDb
        e = dbxml.getElementsByTagName('shasum')[0]
        self.shasum = e.childNodes[0].data
        if DEBUG: 
            print e, self.shasum
        #----------------------------- retrieve program minimum version required
        e = dbxml.getElementsByTagName('milestone')[0]
        if e == None:
            milestone = 0
        else:
            milestone = int(e.childNodes[0].data)
        e = dbxml.getElementsByTagName('major')[0]
        if e == None:
            major = 0
        else:
            major = int(e.childNodes[0].data)
        e = dbxml.getElementsByTagName('minor')[0]
        if e == None:
            minor = 0
        else:
            minor = int(e.childNodes[0].data)
        e = dbxml.getElementsByTagName('patch')[0]
        if e == None:
            patch = 0
        else:
            patch = int(e.childNodes[0].data)
        if self.newDb > self.dbversion:
            if ((progInfo.SWMilestone,progInfo.SWMajor,progInfo.SWMinor,progInfo.SWPatchLevel) 
                < (milestone,major,minor,patch)):
                return 100
            else:
                return 10
        return 0
        
    def GetDB(self):
        try:
            conn = httplib.HTTPConnection(self.webSite,timeout=4)
            conn.request("GET", self.__dbfile)
            r1 = conn.getresponse()
            hdrs = r1.getheaders()
            fileSize = 0
            for h in hdrs:
                if DEBUG: print h
                if h[0] == 'content-length':
                    fileSize = int(h[1])
                    break
        except Exception:
            return False
        #print r1.status, r1.reason
        if r1.status != 200:
            return False        
        if DEBUG: 
            print r1.status, r1.reason
        pg = ProgressDialog(title='Get new catalog...',
                            text='')
        pg.show()
        dbf = open(self.updateFile,'wb')
        letti = 0
        while True:
            while gtk.events_pending():
                gtk.main_iteration(block=False)
            dati = r1.read(4096)
            if len(dati) == 0:
                break
            dbf.write(dati)
            letti += len(dati)
            #pg.progressBar.set_text(str(fileSize - letti)+' bytes to go...')
            pg.progressBar.set_fraction(float(letti)/fileSize)
        dbf.close()
        pg.hide()
        conn.close()
        #---------------------------------------------------------- compute hash
        h = hashlib.sha256()
        dbf = open(self.updateFile,'rb')
        while True:
            dati = dbf.read(4096)
            if len(dati) == 0:
                break
            h.update(dati)
        dbf.close()
        computedShasum = h.hexdigest()
        if DEBUG: 
            print computedShasum, self.shasum
        if self.shasum != computedShasum:
            try:
                os.unlink(self.updateFile)
            except (IOError,OSError):
                pass
            return False
        return True
    