'''
Created on 13/mar/2012

@author: mario
'''

import gtk
import base64
from ProgressDialog import ProgressDialog


def encodeImage64(fileImg):
    try:
        f = open(fileImg,'rb')
    except (IOError,OSError):
        return ''
    s = base64.b64encode(f.read())
    f.close()
    return s


class ExportHTML(gtk.Dialog):
    '''
    classdocs
    '''

    def writeHTMLList(self,htmlOut):
        
        if self.imgSize.get_active() == 0:
            size = 75
        elif self.imgSize.get_active() == 1:
            size = 100
        elif self.imgSize.get_active() == 2:
            size = 150
        else:
            size = 200
        if self.textSize.get_active() == 0:
            ts = 'font-size:small;'
        elif self.textSize.get_active() == 2:
            ts = 'font-size:large;'
        else:
            ts = ''
        totalbricks = len(self.currList)
        numbricks = totalbricks
        pr = ProgressDialog(title='Exporting HTML list',
                            parent=self,text=str(numbricks)+' bricks to go...')
        pr.show()
        htmlOut.write('<!DOCTYPE xhtml>\n<html>\n')
        htmlOut.write(
"""
<head>
<style type="text/css">
body { font-family:sans-serif;}
table,th,td { empty-cells:show;border-collapse:collapse; border:1px solid gray; """ + ts + """ padding:0.2em; }
.color { border:0 solid white }
.decor { border:0 solid white; text-align:center; }
img { border:1 solid white; vertical-align:middle }
img:hover { border:1 dotted black }
</style>
</head>
""")
        htmlOut.write('<body>\n')
        htmlOut.write('<table border="1"><thead><tr><th>ID</th><th>BLink ID</th><th>LDD ID</th><th>Color</th><th>Qty</th>')
        if self.includeCheck.get_active() and not self.includeImg.get_active():
            htmlOut.write('<th>Check</th>')
        if self.includeImg.get_active() and not self.includeCheck.get_active():
            htmlOut.write('<th>Brick shape</th>')
        if self.includeImg.get_active() and self.includeCheck.get_active():
            htmlOut.write('<th>Brick shape/Check</th>')
        htmlOut.write('<th>Description</th></tr></thead>\n<tbody>\n')
        for b in self.currList:
            while gtk.events_pending():
                gtk.main_iteration(block=False)
            htmlOut.write('  <tr><td>{0}</td><td>{1}</td><td>{2}</td><td><table width="100%" class="color"><tr><td width="20%" class="color">{3}</td>'.format(b[13],b[1],b[7],b[14]))
            htmlOut.write('<td class="color"><div style="display:inline;border-style:solid;border-width:0 1em 0 1em;border-color:{0}"/></td>'.format(b[8]))
            htmlOut.write('<td class="color">{0}</td></tr><tr><td colspan="3" class="decor">{1}</td></tr></table></td>'.format(b[9],'Decorated' if b[15] else ''))
#            if b[15]:
#                #------------------------------------------------ decorated part
#                htmlOut.write('<td style="font-size:120%;text-align:center;">Y</td>')
#            else:
#                htmlOut.write('<td></td>')
            htmlOut.write('<td>{0}</td>'.format(b[2]))
            if self.includeCheck.get_active() and not self.includeImg.get_active():
                htmlOut.write('<td style="text-align:center;padding:0.5 em;"><input type="checkbox"></input></td>')
            if self.includeImg.get_active() and not self.includeCheck.get_active():
                brickFile = self.imgCache.brickImgLDD(b[7])
                if brickFile != None:
                    htmlOut.write('<td style="text-align:center;padding:0.5 em;"><img width="{0}" height="{1}" src="data:image/png;base64,'.format(size,size))
                    htmlOut.write(encodeImage64(brickFile))
                    htmlOut.write('"/></td>')
                else:
                    htmlOut.write('<td>No brick image </td>')
            if self.includeImg.get_active() and self.includeCheck.get_active():
                htmlOut.write('<td style="text-align:center;padding:0.5 em;"><label style="" for="{1}"><input type="checkbox" id="{0}">'.format(b[13],b[13]))
                brickFile = self.imgCache.brickImgLDD(b[7])
                if brickFile != None:
                    htmlOut.write('<img width="{0}" height="{1}" src="data:image/png;base64,'.format(size,size))
                    htmlOut.write(encodeImage64(brickFile))
                    htmlOut.write('"/></label></td>')
                else:
                    htmlOut.write('No brick image </label></td>')
                

            htmlOut.write('<td>{0}</td>'.format(b[6]))
            htmlOut.write('</tr>\n')
            v = pr.get_property("visible")
            if not v:
                break
            numbricks -= 1
            pr.progressBar.set_text(str(numbricks)+' bricks to go...')
            pr.progressBar.set_fraction(1.0-(float(numbricks)/totalbricks))
            
        htmlOut.write('</tbody></table></body></html>\n')
        pr.hide()
        pr.destroy()


    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
                
            if len(self.fileOutput.get_text()) == 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="No output file is given, cannot export.")
                msg.set_title('No output file given')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            try:
                htmlOut = open(self.fileOutput.get_text(),'w')
            except IOError as e:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="Cannot open output file, reason:"+repr(e))
                msg.set_title('Error opening file')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            
            self.writeHTMLList(htmlOut)
            htmlOut.close()            



    def fileChooseCB(self,widget):
        dlg = gtk.FileChooserDialog(title='Output file',parent=self,action=gtk.FILE_CHOOSER_ACTION_SAVE,
                                    buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT))
        dlg.set_do_overwrite_confirmation(True)
        response = dlg.run()
        dlg.hide()
        if response == gtk.RESPONSE_ACCEPT:
            self.fileOutput.set_text(dlg.get_filename())



    def __init__(self,title="Export as printable HTML", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT), 
                 currList=None,catalog=None,imageCache=None):
        '''
        Constructor
        '''
        super(ExportHTML, self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        
        self.currList = currList
        self.catalog = catalog
        self.imgCache = imageCache
        
        #----------------------------------------------------------- main window
        self.connect('response',self.responseCB)
      
        #-------------------------------------------------------- primary layout
        self.vBox = self.get_content_area()
        self.set_default_size(600,-1)
        table = gtk.Table(2,4)
        self.includeImg = gtk.CheckButton('Include brick image')
        self.includeImg.set_active(True)
        self.includeCheck = gtk.CheckButton('Include a check button')
        self.includeCheck.set_active(True)
        self.fileOutput = gtk.Entry()
        self.fileOutput.set_editable(False)
        self.fileChoose = gtk.Button('Select output file...')
        self.fileChoose.connect('clicked',self.fileChooseCB)
        lab2 = gtk.Label('Output file:')
        lab2.set_alignment(1,0.5)
        table.attach(lab2,0,1,1,2,xoptions=gtk.FILL)
        table.attach(self.fileOutput,1,3,1,2,xpadding=3)
        table.attach(self.fileChoose,3,4,1,2,xpadding=3)
        self.vBox.pack_start(table,False)        
        frame = gtk.Frame('Export options')
        table1 = gtk.Table(3,3)
        table1.set_row_spacings(3)
        self.textSize = gtk.combo_box_new_text()
        self.textSize.append_text('Default')
        self.textSize.append_text('Large')
        self.textSize.append_text('Very large')
        self.textSize.set_active(0)
        self.imgSize = gtk.combo_box_new_text()
        self.imgSize.append_text('Small (75x75px)')
        self.imgSize.append_text('Default (100x100px)')
        self.imgSize.append_text('Large (150x150px)')
        self.imgSize.append_text('Very large (200x200px)')
        self.imgSize.set_active(1)
        table1.attach(self.includeImg,0,1,0,1)
        table1.attach(self.includeCheck,0,1,1,2)
        lab = gtk.Label('Text size:')
        lab.set_alignment(1,0.5)
        table1.attach(lab,1,2,1,2,xoptions=gtk.SHRINK)
        table1.attach(self.textSize,2,3,1,2)
        lab = gtk.Label('Image size:')
        lab.set_alignment(1,0.5)
        table1.attach(lab,1,2,0,1,xoptions=gtk.SHRINK)
        table1.attach(self.imgSize,2,3,0,1)
        frame.add(table1)
        self.vBox.pack_start(frame,False)
        self.vBox.show_all()
        