'''
Created on 16/ott/2012

@author: mario
'''

import gtk
import zipfile
import random
import os.path
from ProgressDialog import ProgressDialog

def LDrawImportLib(parent,ldrawzip,catalog=None):

    ldrzip = zipfile.ZipFile(ldrawzip,'r')
    ldrlist = ldrzip.namelist()
    #--------------------------------------- checks for right LDraw library file
    if 'ldraw/parts/3001.dat' not in ldrlist:
        ldrzip.close()
        return False
    numfiles = len(ldrlist)
    catalog.cleanLdrPartsTable()
    procFiles = 0
    pr = ProgressDialog(parent=parent,title='Importing LDraw parts library',flags=gtk.DIALOG_MODAL,
                        text=str(numfiles)+' files to check...')
    pr.show()
    #print numfiles
    for f in ldrlist:
        while gtk.events_pending():
            gtk.main_iteration(block=False)
        d,ldrId = os.path.split(f)
        m = os.path.split(d)[1]
        e = os.path.splitext(f)[1]
        #print d,ldrId,m,e
        procFiles += 1
        if m == 'parts' and e == '.dat':
            #----------------------------------------- it is a LDraw brick model
            ldrKeywords = ''
            ldrDescr = ''
            ldrCategory = ''
            if pr.get_property("visible"):
                if (procFiles % (int(random.random() * 50) + 10)) == 0:
                    pr.progressBar.set_text(str(numfiles-procFiles)+' files to check...')
                    pr.progressBar.set_fraction(float(procFiles)/numfiles)
            else:
                break
            zipMember = ldrzip.open(f, 'rU')
            firstLine = True
            for l in zipMember:
                if firstLine:
                    ldrDescr = l[l.find('0')+1:]
                    firstLine = False
                    continue
                ldrLine = l.split()
                if len(ldrLine) > 1 and ldrLine[0] == '0':
                    if ldrLine[1].upper() == '!CATEGORY':
                        ldrCategory = l[l.find('!CATEGORY')+10:]
                        continue
                    if ldrLine[1].upper() == '!KEYWORDS':
                        ldrKeywords = l[l.find('!KEYWORDS')+10:]
                else:
                    continue
            catalog.insertLdrPart(ldrId,ldrDescr.strip().decode('utf-8'),ldrCategory.strip().decode('utf-8'),ldrKeywords.strip().decode('utf-8'))
    pr.hide()
    pr.destroy()
    catalog.commit()
    ldrzip.close()
    return True
            
            
        