'''
Created on 12/set/2011

update BL parts/color<->LEGO(r) partno 

@author: mario
'''

import gtk
import xml.parsers.expat
from BrickException import BrickException


class UpdateBLCodes():
    '''
    classdocs
    '''

    def __init__(self,blxml,catalog,sbwidget,context):
        '''
        Constructor
        '''
        self.blxml = blxml
        self.catalog = catalog
        self.statusBar = sbwidget
        self.sbContext = context
        #-------------------------------------------------- creates Expat parser
        self.Parser = xml.parsers.expat.ParserCreate()
        #----------------------------------------------------- defines callbacks
        self.Parser.CharacterDataHandler = self.hCharData
        self.Parser.StartElementHandler = self.hStartEl
        self.Parser.EndElementHandler = self.hEndEl
        self.Parser.buffer_text = True
        self.itemCount = 0
        self.fCodes = False
        self.fItem = False
        self.currVal = None

    def parse(self):
        self.catalog.cleanBLCodesTable()
        self.Parser.ParseFile(self.blxml)


    def hStartEl(self,name,attrs):
        if gtk.events_pending():
            gtk.main_iteration(block=False)
        if name == 'CODES':
            #--------------------------------- ok, this is a start in BL catalog
            self.fCodes = True
            return
        if name == 'ITEM':
            #-------------------------- it's ok if we are into "catalog" element
            if self.fCodes:
                self.fItem = True
                self.itemID = None
                self.itemCode = None
                self.itemType = None
                self.itemColor = None
                return
            else:
                raise BrickException("Invalid BL part/color dump file, 'ITEM' element outside 'CATALOG'")
        
    def hCharData(self,data):
        self.currVal = data.strip()
        
    def hEndEl(self,name):
        if name == 'ITEMTYPE':
            self.itemType = self.currVal
            self.currVal = None
            return
        if name == 'ITEMID':
            self.itemID = self.currVal
            self.currVal = None
            return
        if name == 'COLOR':
            self.itemColor = self.currVal
            self.currVal = None
            return
        if name == 'CODENAME':
            self.itemCode = self.currVal
            self.currVal = None
            return
        if name == 'ITEM':
            #----------------------------- we have all data on item, store on DB
            self.fItem = False
            if self.itemType == 'P':
                self.catalog.insertBLCode(self.itemID,self.itemColor,self.itemCode)
            self.itemCount += 1
            if (self.itemCount % 1000) == 0:
                self.statusBar.pop(self.sbContext)
                self.statusBar.push(self.sbContext,'Reading part codes: '+str(self.itemCount))
        if name == 'CODES':
            #-------------------------------------- we are at the end of catalog
            self.statusBar.pop(self.sbContext)
            self.statusBar.push(self.sbContext,'Finished, part codes in database: '+str(self.itemCount))
        
            self.catalog.commit()
            
