'''
Created on 2/gen/2012

@author: mario
'''

import gtk
import xml.parsers.expat
from BrickException import BrickException


class ParseBLSetXML():
    '''
    classdocs
    '''

    def __init__(self,blxml,partOnly,noCntrp,currList,cpList,altList,pWidget):
        '''
        Constructor
        '''
        self.blxml = blxml
        self.partOnly = partOnly
        self.noCntrp = noCntrp
        self.currList = currList
        self.cpList = cpList
        self.altList = altList
        self.pWidget = pWidget
        #-------------------------------------------------- creates Expat parser
        self.Parser = xml.parsers.expat.ParserCreate()
        #----------------------------------------------------- defines callbacks
        self.Parser.CharacterDataHandler = self.hCharData
        self.Parser.StartElementHandler = self.hStartEl
        self.Parser.EndElementHandler = self.hEndEl
        self.Parser.buffer_text = True
        self.itemCount = 1
        self.fInv = False
        self.fItem = False
        self.currVal = None

    def parse(self):
        try:
            self.Parser.ParseFile(self.blxml)
        except xml.parsers.expat.ExpatError as e:
            raise BrickException('Invalid BL set inventory file, syntax error in line: '+str(e.lineno))


    def hStartEl(self,name,attrs):
        #-------------------------------------------- let the GUI updates itself
        while gtk.events_pending():
            gtk.main_iteration(block=False)
        if name == 'INVENTORY' or name == 'ORDERS':
            #--------------------------------- ok, this is a start in BL inventory
            #-------------------------- or a BL order list dump or a wanted list
            self.fInv = True
            return
        if name == 'ITEM':
            #-------------------------- it's ok if we are into "inventory" element
            if self.fInv:
                self.fItem = True
                self.ItemType = None
                self.itemId = None
                self.itemQty = None
                self.itemCol = None
                self.itemExtra = None
                self.itemAlt = False
                self.itemMatch = 0
                self.itemCtrp = None
                return
            else:
                raise BrickException("Invalid BL set inventory file, 'ITEM' element outside 'INVENTORY'")
        if not self.fItem and not self.fInv:
            raise BrickException("Invalid BL set inventory file, unknown tag '"+name+"' in file")
        
    def hCharData(self,data):
        self.currVal = data.strip()
        
    def hEndEl(self,name):
        if name == 'ITEMTYPE':
            self.itemType = self.currVal
            self.currVal = None
            return
        if name == 'ITEMID':
            self.itemId = self.currVal
            self.currVal = None
            return
        if name == 'QTY' or name == 'MINQTY':   # for wanted list, too
            self.itemQty = self.currVal
            self.currVal = None
            return
        if name == 'COLOR':
            self.itemCol = self.currVal
            self.currVal = None
            return
        if name == 'EXTRA':
            self.itemExtra = True if self.currVal.upper() == 'Y' else False
            self.currVal = None
            return
        if name == 'ALTERNATE':
            self.itemAlt = True if self.currVal.upper() == 'Y' else False
            self.currVal = None
            return
        if name == 'MATCHID':
            self.itemMatch = int(self.currVal)
            self.currVal = None
            return
        if name == 'COUNTERPART':
            self.itemCtrp = True if self.currVal.upper() == 'Y' else False
            self.currVal = None
            return
        if name == 'ITEM':
            #----------------------------- we have all data on item, store on return vars
            self.fItem = False
            if self.partOnly and self.itemType.upper() != 'P':
                return
            if self.itemCtrp:
                if self.noCntrp:
                    return
                else:
                    self.cpList[str(self.itemCount)] = (self.itemType,
                                                           self.itemId,
                                                           self.itemQty,
                                                           self.itemCol,
                                                           self.itemExtra,
                                                           self.itemAlt,
                                                           self.itemMatch,
                                                           self.itemCtrp
                                                           )
            if self.itemAlt:
                self.altList[str(self.itemMatch)] = (self.itemType,self.itemId,self.itemQty,self.itemCol,
                                                     self.itemExtra,self.itemAlt,self.itemMatch,self.itemCtrp)
            else:
                self.currList[str(self.itemCount)] = (self.itemType,self.itemId,self.itemQty,self.itemCol,
                                                     self.itemExtra,self.itemAlt,self.itemMatch,self.itemCtrp)
            if (self.itemCount % 20) == 0:
                self.pWidget.set_text(str(self.itemCount))
            self.itemCount += 1
            
            
        if name == 'INVENTORY' or name == 'ORDERS':
            #-------------------------------------- we are at the end of catalog
            self.fInv = False

        
                