'''
Created on 19/set/2011

@author: mario
'''


import gobject
import gtk
import BrickListStore
from PartsMaintDialog import PMEditDialog
from BLPartSearch import BLPartSearch

class PartEditDialog(gtk.Dialog):
    '''
    classdocs
    '''

    #----------------------------------------------------------------- callbacks

    '''
    callback to work on dialog close
    '''    
    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
            #------------------------------------------------ save edits in part
            try:
                lddid = int(self.lddid.get_text())
            except ValueError:
                lddid = 0
            
            if lddid == 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                                message_format="LDD part ID must be an integer grater than 0.")
                msg.set_title('Wrong part ID')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return

            i = self.lddcolor.get_active_iter()
            if i != None:
                model = self.lddcolor.get_model()
                color,name,rgb = model.get(i,0,1,2)
            else:
                color,name,rgb = (0,'no match',None)
                
            i = self.blcolor.get_active_iter()
            if i != None:
                model = self.blcolor.get_model()
                blcolor,blname,blrgb = model.get(i,0,1,2)
            else:
                blcolor,blname,blrgb = (0,'no match',None)
                    
            self.part = (self.part[0],
                         self.blid.get_text(),
                         self.partQty.get_value_as_int(),
                         str(blcolor),
                         self.part[4],
                         self.part[5],
                         self.descr.get_text(),
                         lddid,
                         rgb,
                         name,
                         blrgb,
                         blname,
                         self.part[12],
                         self.part[13],
                         color,
                         self.decorFlag.get_active(),
                         self.part[16]
                         )
            print self.part
            #---------------------------------------------- writes modified part
            path = self.blView.get_cursor()[0]
            self.blStore[path] = self.part
           
    def addPartMapCB(self,widget):
        lddid = self.lddid.get_text()
        try:
            lddid = int(self.lddid.get_text())
        except ValueError:
            lddid = 0
        if lddid == 0:
            msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                            message_format="LDD part ID must be an integer grater than 0.")
            msg.set_title('Wrong part ID')
            msg.run()
            msg.hide()
            msg.destroy()
            return
        dlg = PMEditDialog(title='Save to Part Mapping DB', parent=self,catalog=self.catalog,imgCache=self.imgCache)
        dlg.lddid.set_text(str(lddid))
        dlg.blid.set_text(self.blid.get_text())
        dlg.notes.set_text(self.descr.get_text())
        dlg.bl2ldd.set_active(True)
        dlg.ldd2bl.set_active(True)
        response = dlg.run()
        dlg.hide()
        if response != gtk.RESPONSE_ACCEPT:
            return
        try:
            lddid = int(dlg.lddid.get_text())
            if lddid == 0:
                raise ValueError
        except ValueError:
            msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                            message_format="LDD ID must be numeric and greater than 0")
            msg.set_title('Wrong LDD ID')
            response = msg.run()
            msg.hide()
            msg.destroy()
            return
        blid = dlg.blid.get_text().lower()
        if self.catalog.isPartMap(lddid,blid):
            msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL)
            msg.set_markup("Duplicated part mapping\nLDD ID: <b>"+str(lddid)+
                               "</b> BL ID: <b>"+blid+'</b>')
            msg.set_title('Mapping already exists')
            response = msg.run()
            msg.hide()
            msg.destroy()
            return
        r = self.catalog.partMapLDD2BLExists(lddid)
        s = self.catalog.partMapBL2LDDExists(blid)
        if ((len(r) > 0 and dlg.ldd2bl.get_active()) or
            (len(s) > 0 and dlg.bl2ldd.get_active())):
            #------------- only one part can be converted from LDD to BL
            msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL)
            if len(r) > 0 and dlg.ldd2bl.get_active():
                msg.set_markup("Conversion from LDD to BL for this part already exists: <b>"+str(r[0][0])+
                               "</b> BL ID: <b>"+r[0][1]+'</b>')
            elif len(s) > 0 and dlg.bl2ldd.get_active():
                msg.set_markup("Conversion from BL to LDD for this part already exists: <b>"+str(s[0][0])+
                               "</b> BL ID: <b>"+s[0][1]+'</b>')
            msg.set_title('Error')
            response = msg.run()
            msg.hide()
            msg.destroy()
            return
        self.catalog.insertPartMapping(lddid,blid,dlg.bl2ldd.get_active(),
                                       dlg.ldd2bl.get_active(),dlg.notes.get_text().decode('utf-8'),True,0)
        self.catalog.commit()
            
    def searchBLCB(self,widget):
        dlg = BLPartSearch(parent=self,catalog=self.catalog,imgCache=self.imgCache)
        response = dlg.run()
        dlg.hide()
        if response == gtk.RESPONSE_ACCEPT:
            c = dlg.resview.get_cursor()[0]
            if c == None:
                return
            i = dlg.reslist.get_iter(c)
            self.blid.set_text(dlg.reslist.get(i,0)[0])
            self.descr.set_text(dlg.reslist.get(i,1)[0])
 
    '''
    reads color list from table colormap in catalog
    @return: a gtk.ListStore
    '''
    def buildLDDcolorList(self):
        #------------------------------------------------- query color table
        c = self.catalog.getLDDColors()
        
        #------------------------------------ iterates through query results
        colorlist = gtk.ListStore(gobject.TYPE_INT,gobject.TYPE_STRING,gobject.TYPE_STRING)
        for r in c:
            colorlist.append(row=(r[0],r[1],r[2]))

        return colorlist
        
    def buildBLColorList(self):
        c = self.catalog.getBLColors()
        colorlist = gtk.ListStore(gobject.TYPE_INT,gobject.TYPE_STRING,gobject.TYPE_STRING)
        for r in c:
            colorlist.append(row=(r[0],r[1],r[2]))

        return colorlist 

    def copyBL2LDDCB(self,widget):
        self.lddid.set_text(self.blid.get_text())
        
    
    def convertLDDColorCB(self,widget):
        i = self.lddcolor.get_active_iter()
        if i != None:
            model = self.lddcolor.get_model()
            color = model.get(i,0)[0]
            c = self.catalog.colorLDD2BL(color)[0][1]
            model = self.blcolor.get_model()
            for r in model:
                if c == model.get_value(r.iter,0):
                    self.blcolor.set_active_iter(r.iter)
                    break

    def convertBLColorCB(self,widget):
        i = self.blcolor.get_active_iter()
        if i != None:
            model = self.blcolor.get_model()
            color = model.get(i,0)[0]
            c = self.catalog.colorBL2Ldd(color)[0][3]
            model = self.lddcolor.get_model()
            for r in model:
                if c == model.get_value(r.iter,0):
                    self.lddcolor.set_active_iter(r.iter)
                    break


    def convertLDDPartCB(self,widget):
        try:
            lddid = int(self.lddid.get_text())
        except ValueError:
            lddid = 0
        if lddid != 0:
            c = self.catalog.partLdd2Bl(lddid)
            if len(c) != 0:
                self.blid.set_text(c[0][0])


    def convertBLPartCB(self,widget):
        blid = self.blid.get_text()
        if len(blid) != 0:
            partno,decor = self.catalog.detectBLdecoration(blid)
            if decor:
                c = self.catalog.partBl2Ldd(partno)
                if len(c) != 0:
                    lddid = c[0][0]
                    self.lddid.set_text(str(lddid))
                    self.decorFlag.set_active(decor)
                else:
                    c = self.catalog.partBl2Ldd(blid)
                    if len(c) != 0:
                        lddid = c[0][0]
                        self.lddid.set_text(str(lddid))
                        self.decorFlag.set_active(decor)
            else:
                c = self.catalog.partBl2Ldd(blid)
                if len(c) != 0:
                    lddid = c[0][0]
                    self.lddid.set_text(str(lddid))
                    self.decorFlag.set_active(decor)



    #-------------------------------------------------------- interface building
    def __init__(self,title="Edit Part", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_SAVE,gtk.RESPONSE_ACCEPT), 
                 store=None,view=None,catalog=None,imgCache=None):
        super(PartEditDialog,self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        
        self.dialogTitle = title
        self.blStore = store
        self.blView = view
        self.catalog = catalog
        self.part = None
        self.modified = False
        self.imgCache = imgCache
        self.idx = BrickListStore.getIndex()
                
        #----------------------------------------------------------- main window
        self.connect('response',self.responseCB)
      
        #-------------------------------------------------------- primary layout
        self.vBox = self.get_content_area()
        
        path = self.blView.get_cursor()
        self.part = self.blStore[path[0]] 
        
        frame = gtk.Frame('BrickLink data')
        table = gtk.Table(3,4)
        table.set_border_width(3)
        table.set_row_spacings(4)
        lab = gtk.Label('Part ID:')
        self.blid = gtk.Entry()
        self.blid.set_text(self.part[self.idx['blid']])
        lab.set_alignment(1,0.5)
        table.attach(lab,0,1,0,1,xoptions=gtk.FILL,xpadding=3)
        table.attach(self.blid,1,2,0,1,xpadding=3)
        lab = gtk.Label('Description:')
        lab.set_alignment(1,0.5)
        table.attach(lab,0,1,1,2,xoptions=gtk.FILL,xpadding=3)
        self.descr = gtk.Entry()
        self.descr.set_text(self.part[self.idx['descr']])
        table.attach(self.descr,1,4,1,2,xpadding=3)
        lab = gtk.Label('Color:')
        lab.set_alignment(1,0.5)
        table.attach(lab,0,1,2,3,xoptions=gtk.FILL,xpadding=3)
        blcolorlist = self.buildBLColorList()
        self.blcolor = gtk.ComboBox(model=blcolorlist)
        col = gtk.CellRendererText()
        col.set_fixed_size(16,-1)
        colorID = gtk.CellRendererText()
        name = gtk.CellRendererText()
        self.blcolor.pack_start(colorID,False)
        self.blcolor.pack_start(col,False)
        self.blcolor.pack_start(name,False)
        self.blcolor.add_attribute(colorID,'text',0)
        self.blcolor.add_attribute(col,'background',2)
        self.blcolor.add_attribute(name,'text',1)
        model = self.blcolor.get_model()
        for r in model:
            if self.part[self.idx['blcolorid']] == str(model.get_value(r.iter,0)):
                self.blcolor.set_active_iter(r.iter)
                break
        table.attach(self.blcolor,1,2,2,3,xpadding=3)
        self.searchBL = gtk.Button('Search...')
        self.searchBL.connect('clicked',self.searchBLCB)
        table.attach(self.searchBL,3,4,0,1,xpadding=3,xoptions=gtk.FILL)
        self.convertLDDPart = gtk.Button('Convert LDD ID')
        self.convertLDDPart.connect('clicked',self.convertLDDPartCB)
        table.attach(self.convertLDDPart,2,3,0,1)
        self.convertLDDColor = gtk.Button('Convert LDD Color')
        self.convertLDDColor.connect('clicked',self.convertLDDColorCB)
        table.attach(self.convertLDDColor,2,3,2,3)
        frame.add(table)
        self.vBox.set_spacing(5)
        self.vBox.pack_start(frame,False)
        #self.vBox.pack_start(gtk.HSeparator(),False)
        #-------------------------------------------------------- LDD data frame
        frame = gtk.Frame('LDD data')
        table = gtk.Table(3,4)
        table.set_border_width(3)
        table.set_row_spacings(4)
        self.copyBL2LDD = gtk.Button('Copy ID from BL')
        self.copyBL2LDD.connect('clicked',self.copyBL2LDDCB)
        table.attach(self.copyBL2LDD,3,4,0,1,xpadding=3)
        self.convertBLPart = gtk.Button('Convert BL ID')
        self.convertBLPart.connect('clicked',self.convertBLPartCB)
        table.attach(self.convertBLPart,2,3,0,1)
        self.convertBLColor = gtk.Button('Convert BL Color')
        self.convertBLColor.connect('clicked',self.convertBLColorCB)
        table.attach(self.convertBLColor,2,3,1,2)

        lab1 = gtk.Label('Part ID:')
        lab1.set_alignment(1,0.5)
        table.attach(lab1,0,1,0,1,xoptions=gtk.FILL)
        self.lddid = gtk.Entry()
        self.lddid.set_text(str(self.part[self.idx['lddid']]))
        table.attach(self.lddid,1,2,0,1,xpadding=3,xoptions=gtk.FILL)
        colorlist = self.buildLDDcolorList()
        self.lddcolor = gtk.ComboBox(model=colorlist)
        col = gtk.CellRendererText()
        col.set_fixed_size(16,-1)
        colorID = gtk.CellRendererText()
        name = gtk.CellRendererText()
        self.lddcolor.pack_start(colorID,False)
        self.lddcolor.pack_start(col,False)
        self.lddcolor.pack_start(name,False)
        self.lddcolor.add_attribute(colorID,'text',0)
        self.lddcolor.add_attribute(col,'background',2)
        self.lddcolor.add_attribute(name,'text',1)
        model = self.lddcolor.get_model()
        for r in model:
            if self.part[self.idx['lddcolorid']] == model.get_value(r.iter,0):
                self.lddcolor.set_active_iter(r.iter)
                break
        lab2 = gtk.Label('    Color ID:')
        lab2.set_alignment(1,0.5)
        table.attach(lab2,0,1,1,2,xoptions=gtk.FILL)
        table.attach(self.lddcolor,1,2,1,2,xpadding=4,xoptions=gtk.FILL)
        self.decorFlag = gtk.CheckButton('Decorated part')
        self.decorFlag.set_active(self.part[self.idx['decorated']])
        table.attach(self.decorFlag,1,2,2,3,xoptions=gtk.FILL)
        self.adj = gtk.Adjustment(lower=0,upper=2000000000,step_incr=1,page_incr=50)
        self.partQty = gtk.SpinButton(adjustment=self.adj,digits=0)
        self.partQty.set_value(self.part[self.idx['qty']])
        lab = gtk.Label('Quantity:')
        lab.set_alignment(1,0.5)
        table.attach(lab,0,1,3,4,xoptions=gtk.FILL)
        table.attach(self.partQty,1,2,3,4,xpadding=4,xoptions=gtk.FILL)
        frame.add(table)
        self.vBox.pack_start(frame,False)
        self.addPartMap = gtk.Button('Add Part to mapping DB')
        self.addPartMap.connect('clicked',self.addPartMapCB)
        self.vBox.pack_start(self.addPartMap)
        self.set_default_size(500,-1)
        self.vBox.show_all()
                