'''
Created on 23/set/2011

@author: mario
'''

import gtk
import gobject


class Dialog(gtk.Dialog):
    '''
    classdocs
    '''
    
    
    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
            if self.addTypeMoc.get_active():
                if len(self.mocName.get_text()) < 1:
                    msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                                message_format="You must assign a name to your MOC")
                    msg.set_title('Empty MOC name')
                    msg.run()
                    msg.hide()
                    msg.destroy()
                    self.emit_stop_by_name('response')
                    return
            else:
                c = self.resview.get_cursor()[0]
                if c == None:
                    msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                                message_format="You must select a set")
                    msg.set_title('No set selected')
                    msg.run()
                    msg.hide()
                    msg.destroy()
                    self.emit_stop_by_name('response')
                    return
                    
                

    def selectTypeCB(self,widget):
        if self.addTypeSet.get_active():
            # it is a set, disable "moc" controls
            self.mocName.set_sensitive(False)
            self.setid.set_sensitive(True)
            self.setDescr.set_sensitive(True)
            self.setyear.set_sensitive(True)
            
        else:
            self.mocName.set_sensitive(True)
            self.setid.set_sensitive(False)
            self.setDescr.set_sensitive(False)
            self.setyear.set_sensitive(False)

    def setSearchCB(self,widget,column):
        self.resview.set_search_column(column)
        
    def yearSelectionCB(self,widget,op):
        self.yearOp = op
        
    def searchSetCB(self,widget):
        text = self.setDescr.get_text()
        setid = self.setid.get_text()
        try:
            year = int(self.setyear.get_text())
        except ValueError:
            year = 0
                
        self.reslist.clear()
        if len(setid) > 0:
            setid = setid + '%'
            #---------------------------------------- search by id (like match)
            if year > 0:
                c = self.catalog.getBLSetByIDYear(setid,year,self.yearOp)
            else:
                c = self.catalog.getBLSetByID(setid)                
        elif len(text) > 0:
            #----------------------------------- search by generic text and year
            if year > 0:
                c = self.catalog.ftsYearBLSet(text,year,self.yearOp)
            else:
                c = self.catalog.ftsBLSet(text)
        elif year > 0:
            #----------------------------------------------- search only by year
            c = self.catalog.getBLSetByYear(year,self.yearOp)
            
            
        for r in c:
            row = (r[0],r[1],r[2],r[3],r[4])
            self.reslist.append(row=row)
        
   

    def __init__(self,title="Add bricks to catalog", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_APPLY,gtk.RESPONSE_ACCEPT), 
                 catalog=None):
        '''
        Constructor
        '''
        super(Dialog,self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        
        self.dialogTitle = title
        self.catalog = catalog
        
        #----------------------------------------------------------- main window
        self.connect('response',self.responseCB)
      
        #-------------------------------------------------------- primary layout
        self.vBox = self.get_content_area()
        self.setid = gtk.Entry()
        self.setDescr = gtk.Entry()
        self.setyear = gtk.Entry()
        self.rbeq = gtk.RadioButton(label='released this year')
        self.yearOp = '='
        self.rbbefore = gtk.RadioButton(group=self.rbeq,label='released before')
        self.rbafter = gtk.RadioButton(group=self.rbeq,label='released after')
        self.rbeq.connect('toggled',self.yearSelectionCB,'=')
        self.rbbefore.connect('toggled',self.yearSelectionCB,'<=')
        self.rbafter.connect('toggled',self.yearSelectionCB,'>=')
        self.search = gtk.Button('Start search...')
        self.search.connect('clicked',self.searchSetCB)
        self.reslist = gtk.ListStore(gobject.TYPE_INT,
                                     gobject.TYPE_STRING,
                                     gobject.TYPE_STRING,
                                     gobject.TYPE_STRING,
                                     gobject.TYPE_STRING
                                     )
        
        self.resview = gtk.TreeView(self.reslist)
        
        self.crtSetID = gtk.CellRendererText()
        self.crtSetName = gtk.CellRendererText()
        self.crtSetYear = gtk.CellRendererText()
        self.crtSetCategory = gtk.CellRendererText()
        
        self.tvcSetID = gtk.TreeViewColumn('Set ID',self.crtSetID)
        self.tvcSetName = gtk.TreeViewColumn('Set Name ',self.crtSetName)
        self.tvcSetYear = gtk.TreeViewColumn('Year',self.crtSetYear)
        self.tvcSetCategory = gtk.TreeViewColumn('Category',self.crtSetCategory)

        self.tvcSetID.set_resizable(True)
        self.tvcSetName.set_resizable(True)
        self.tvcSetYear.set_resizable(True)
        self.tvcSetCategory.set_resizable(True)
        
        self.tvcSetID.set_attributes(self.crtSetID,text=1)
        self.tvcSetName.set_attributes(self.crtSetName,text=2)
        self.tvcSetYear.set_attributes(self.crtSetYear,text=3)
        self.tvcSetCategory.set_attributes(self.crtSetCategory,text=4)
        
        self.resview.append_column(self.tvcSetID)
        self.resview.append_column(self.tvcSetName)
        self.resview.append_column(self.tvcSetYear)
        self.resview.append_column(self.tvcSetCategory)
        
        self.tvcSetID.set_sort_column_id(1)
        self.tvcSetID.connect('clicked',self.setSearchCB,1)
        self.tvcSetName.set_sort_column_id(2)
        self.tvcSetName.connect('clicked',self.setSearchCB,2)
        self.tvcSetYear.set_sort_column_id(3)
        self.tvcSetYear.connect('clicked',self.setSearchCB,3)
        self.tvcSetCategory.set_sort_column_id(4)
        self.tvcSetCategory.connect('clicked',self.setSearchCB,4)
        
        sw = gtk.ScrolledWindow()
        sw.add(self.resview)
        
        self.vBox.pack_start(sw)
        sep = gtk.HSeparator()
        self.vBox.pack_start(sep,False,padding=3)
        bt = gtk.Table(2,2)
        self.addTypeSet = gtk.RadioButton(label='As Set')
        self.addTypeMoc = gtk.RadioButton(group=self.addTypeSet,label='As MOC')
        self.addTypeSet.connect('toggled',self.selectTypeCB)
        self.addTypeSet.set_active(True)
        bt.attach(self.addTypeSet,0,1,0,1,xpadding=4)
        bt.attach(self.addTypeMoc,0,1,1,2,xpadding=4)

        f = gtk.Frame('Add as Official Set')
        ltable = gtk.Table(3,4)
        ltable.set_border_width(3)
        lab1 = gtk.Label('Set ID: ')
        lab1.set_alignment(1,0.5)
        ltable.attach(lab1,0,1,0,1)
        ltable.attach(self.setid,1,2,0,1,xpadding=4)
        lab2 = gtk.Label('Generic search by set name or category: ')
        lab2.set_alignment(1,0.5)
        ltable.attach(lab2,2,3,0,1)
        ltable.attach(self.setDescr,3,4,0,1)
        ltable.attach(self.search,3,4,2,4)
        lab3 = gtk.Label('Year released: ')
        lab3.set_alignment(1,0.5)
        ltable.attach(lab3,0,1,1,2)
        ltable.attach(self.setyear,1,2,1,2,xpadding=4)
        ltable.attach(self.rbeq,2,3,1,2)
        ltable.attach(self.rbbefore,2,3,2,3)
        ltable.attach(self.rbafter,2,3,3,4)
        f.add(ltable)
        bt.attach(f,1,2,0,1)
        f = gtk.Frame('Add as MOC or generic lot')
        self.mocName = gtk.Entry()
        self.mocName.set_sensitive(False)
        mtable = gtk.Table(2,2)
        mtable.set_border_width(3)
        l = gtk.Label('MOC name / lot description')
        l.set_alignment(1,0.5)
        mtable.attach(l,0,1,0,1,xpadding=4,xoptions=gtk.SHRINK)
        mtable.attach(self.mocName,1,2,0,1)
        f.add(mtable)
        bt.attach(f,1,2,1,2)
        
        self.vBox.pack_start(bt,False)
        f = gtk.Frame('Add options')
        otable = gtk.Table(2,2)
        otable.set_border_width(3)
        otable.set_row_spacings(3)
        self.delParts = gtk.CheckButton('Delete parts added from Current list')
        self.addExtra = gtk.CheckButton('Add extra parts')
        self.delParts.set_active(True)
        self.addExtra.set_active(False)
        otable.attach(self.delParts,0,1,0,1)
        otable.attach(self.addExtra,1,2,0,1)
        f.add(otable)
        self.vBox.pack_start(f,False)
        self.set_default_size(min(gtk.gdk.screen_width()-400,600),
                            min(gtk.gdk.screen_height()-400,400))

        
        self.vBox.show_all()
        