'''
Created on 28/set/2011

@author: mario
'''

import gobject
import gtk

class SetStore(gtk.ListStore):
    '''
    Class derived from GTK ListStore to maintain a set catalog list, sync'd with a table on db
    '''
    
    def read(self):
        '''
        returns a SetStore containing the set catalog
        '''

        c = self.catalog.getAllSetDetails()
        
        self.clear()
        for r in c:
            if r['setid'][0] == '@':
                self.append(row=(r['rowid'],
                                 '-',  
                                 r['setname'][1:],
                                 '-',
                                 r['catname']
                                ))
            else:
                self.append(row=(r['rowid'],
                                 r['setid'],  
                                 r['setname'],
                                 r['setyear'],
                                 r['catname']
                                ))
                      

    def __init__(self,catalog=None):
        '''
        builds all necessary items for set ListStore and associated table on DB
        '''
        super(SetStore,self).__init__(gobject.TYPE_INT,         # rowid
                                      gobject.TYPE_STRING,      # bl set id
                                      gobject.TYPE_STRING,      # bl description
                                      gobject.TYPE_STRING,      # bl year
                                      gobject.TYPE_STRING       # bl category
                                      )
        self.catalog = catalog
        self.read()
        