'''
Created on 28/set/2011

@author: mario
'''

import gtk

class SetView(gtk.TreeView):
    '''
    class derived from GTK TreeView to display sets catalog
    '''
    
    def setSearchCB(self,widget,column):
        self.set_search_column(column)


    def __init__(self,setStore):
        '''
        Constructor
        '''
        
        super(SetView, self).__init__(setStore)

        self.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_HORIZONTAL)

        self.crtID = gtk.CellRendererText()
        self.tvcID = gtk.TreeViewColumn('ID',self.crtID)
        self.tvcID.set_resizable(True)        

        self.crtSetID = gtk.CellRendererText()
        self.tvcSetID = gtk.TreeViewColumn('Set ID',self.crtSetID)
        self.tvcSetID.set_resizable(True)
        
        self.crtName = gtk.CellRendererText()
        self.tvcName = gtk.TreeViewColumn('Set name',self.crtName)
        self.tvcName.set_resizable(True)
        
        self.crtYear = gtk.CellRendererText()
        self.tvcYear = gtk.TreeViewColumn('Year',self.crtYear)
        self.tvcYear.set_resizable(True)
        
        self.crtCat = gtk.CellRendererText()
        self.tvcCat = gtk.TreeViewColumn('Category',self.crtCat)
        self.tvcCat.set_resizable(True)
        
        self.append_column(self.tvcID)
        self.append_column(self.tvcSetID)
        self.append_column(self.tvcName)
        self.append_column(self.tvcYear)
        self.append_column(self.tvcCat)
        
        self.tvcID.set_attributes(self.crtID,text=0)
        self.tvcSetID.set_attributes(self.crtSetID,text=1)
        self.tvcName.set_attributes(self.crtName,text=2)
        self.tvcYear.set_attributes(self.crtYear,text=3)
        self.tvcCat.set_attributes(self.crtCat,text=4)
        
        self.tvcID.set_sort_column_id(0)
        self.tvcSetID.set_sort_column_id(1)
        self.tvcSetID.connect('clicked',self.setSearchCB,1)
        self.tvcName.set_sort_column_id(2)
        self.tvcName.connect('clicked',self.setSearchCB,2)
        self.tvcYear.set_sort_column_id(3)
        self.tvcYear.connect('clicked',self.setSearchCB,3)
        self.tvcCat.set_sort_column_id(4)
        self.tvcCat.connect('clicked',self.setSearchCB,4)
        
               