'''
Created on 12/set/2011

@author: mario
'''

import gtk
import xml.parsers.expat
from BrickException import BrickException


class UpdateBLParts():
    '''
    classdocs
    '''

    def __init__(self,blxml,catalog,sbwidget,context):
        '''
        Constructor
        '''
        self.blxml = blxml
        self.catalog = catalog
        self.statusBar = sbwidget
        self.sbContext = context
        #-------------------------------------------------- creates Expat parser
        self.Parser = xml.parsers.expat.ParserCreate()
        #----------------------------------------------------- defines callbacks
        self.Parser.CharacterDataHandler = self.hCharData
        self.Parser.StartElementHandler = self.hStartEl
        self.Parser.EndElementHandler = self.hEndEl
        self.Parser.buffer_text = True
        self.itemCount = 0
        self.fCat = False
        self.fItem = False
        self.currVal = None

    def parse(self):
        self.catalog.cleanBLPartsTable()
        self.Parser.ParseFile(self.blxml)


    def hStartEl(self,name,attrs):
        if gtk.events_pending():
            gtk.main_iteration(block=False)
        if name == 'CATALOG':
            #--------------------------------- ok, this is a start in BL catalog
            self.fCat = True
            return
        if name == 'ITEM':
            #-------------------------- it's ok if we are into "catalog" element
            if self.fCat:
                self.fItem = True
                self.itemID = None
                self.itemDescr = None
                self.itemCat = None
                self.itemX = None
                self.itemY = None
                self.itemZ = None
                return
            else:
                raise BrickException("Invalid BL parts dump file, 'ITEM' element outside 'CATALOG'")
        
    def hCharData(self,data):
        self.currVal = data.strip()
        
    def hEndEl(self,name):
        if name == 'ITEMID':
            self.itemID = self.currVal
            self.currVal = None
            return
        if name == 'ITEMNAME':
            self.itemDescr = self.currVal
            self.currVal = None
            return
        if name == 'CATEGORY':
            self.itemCat = self.currVal
            self.currVal = None
            return
        if name == 'ITEMDIMX':
            self.itemX = self.currVal
            self.currVal = None
            return
        if name == 'ITEMDIMY':
            self.itemY = self.currVal
            self.currVal = None
            return
        if name == 'ITEMDIMZ':
            self.itemZ = self.currVal
            self.currVal = None
            return
        if name == 'ITEM':
            #----------------------------- we have all data on item, store on DB
            self.fItem = False
            self.catalog.insertBLPart(self.itemID,self.itemDescr,self.itemCat,self.itemX,self.itemY,self.itemZ)
            self.itemCount += 1
            if (self.itemCount % 1000) == 0:
                self.statusBar.pop(self.sbContext)
                self.statusBar.push(self.sbContext,'Reading parts: '+str(self.itemCount))
        if name == 'CATALOG':
            #-------------------------------------- we are at the end of catalog
            self.statusBar.pop(self.sbContext)
            self.statusBar.push(self.sbContext,'Finished, parts in database: '+str(self.itemCount))
        
            self.catalog.commit()
            

        
                