'''
Created on 30/nov/2011

@author: mario
'''

import gtk
from UpdateLdrawXML import UpdateLdrawXML



class UpdateLDrawDialog(gtk.Dialog):
    '''
    classdocs
    '''
    
    
    def responseCB(self,widget,response,*args):
        if response == gtk.RESPONSE_ACCEPT:
            if len(self.fileInput.get_text()) == 0:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="No input file is given, cannot update.")
                msg.set_title('No input file given')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            try:
                ldrawXml = open(self.fileInput.get_text())
            except IOError as e:
                msg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,buttons=gtk.BUTTONS_CANCEL,flags=gtk.DIALOG_MODAL,
                                                message_format="Cannot open input file, reason:"+repr(e))
                msg.set_title('Error opening file')
                msg.run()
                msg.hide()
                msg.destroy()
                self.emit_stop_by_name('response')
                return
            ldmaterials = list()
            ldparts = list()
            parser = UpdateLdrawXML(ldrawXml,ldmaterials,ldparts)
            parser.run()
            ldrawXml.close()
            #-------------------------------------------- now updates the colors
            updatedColCount = 0
            rejectedColCount = 0
            if self.updateColors.get_active():
                for m in ldmaterials:
                    if self.catalog.updateLDrawColor(m[0],m[1]):
                        updatedColCount += 1
                    else:
                        rejectedColCount += 1
                        print "Rejected material: (lego,ldraw)" + repr(m)
            updatedPartCount = 0
            rejectedPartCount = 0
            if self.updateParts.get_active():
                #self.catalog.cleanLDrawmapTable()
                for p in ldparts:
                    if self.catalog.insertLDrawPartMap(p[0],p[1],True,True,'Imported from ldraw.xml'):
                        updatedPartCount += 1
                    else:
                        rejectedPartCount += 1
                        print "Rejected part: (lego,ldraw)" + repr(p)

            self.catalog.commit()
            message = "LDraw conversion tables updated.\n"
            if self.updateColors.get_active():
                message = message + "Colors updated: {0}\nColors rejected: {1}\n".format(updatedColCount,rejectedColCount) 
            else:
                message = message + "Colors not updated.\n"
            if self.updateParts.get_active():
                message = message + "Parts updated: {0}\nParts rejected: {1}".format(updatedPartCount,rejectedPartCount)
            msg = gtk.MessageDialog(type=gtk.MESSAGE_INFO,buttons=gtk.BUTTONS_OK,flags=gtk.DIALOG_MODAL,
                                message_format=message)
            msg.run()
            msg.hide()
            msg.destroy()            
        
        
    def fileChooseCB(self,widget):
        dlg = gtk.FileChooserDialog(title='Select LDraw.xml equivalence file',parent=self,
                                    buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OPEN,gtk.RESPONSE_ACCEPT))
        xmlFilter = gtk.FileFilter()
        xmlFilter.add_pattern("*.xml")
        xmlFilter.add_pattern('*.txt')
        xmlFilter.set_name("XML file")
        dlg.add_filter(xmlFilter)
        allFilter = gtk.FileFilter()
        allFilter.add_pattern("*")
        allFilter.set_name("All files")
        dlg.add_filter(allFilter)
        response = dlg.run()
        dlg.hide()
        if response == gtk.RESPONSE_ACCEPT:
            self.fileInput.set_text(dlg.get_filename())
            
        

    def __init__(self,title="Update LDraw mappings from ldraw.xml file", parent=None, flags=0, 
                 buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_APPLY,gtk.RESPONSE_ACCEPT), 
                 catalog=None):
        '''
        Constructor
        '''
        super(UpdateLDrawDialog, self).__init__(title=title, parent=parent,flags=flags,buttons=buttons)
        
        self.catalog = catalog
        
        #----------------------------------------------------------- main window
        self.connect('response',self.responseCB)
      
        #-------------------------------------------------------- primary layout
        self.vBox = self.get_content_area()
        self.set_default_size(600,-1)
        table = gtk.Table(2,4)
        self.listID = gtk.Entry()
        self.updateColors = gtk.CheckButton('Updates colors')
        self.updateColors.set_active(True)
        self.updateParts = gtk.CheckButton('Updates parts')
        self.updateParts.set_active(True)
        self.fileInput = gtk.Entry()
        self.fileInput.set_editable(False)
        self.fileChoose = gtk.Button('Select ldraw.xml file...')
        self.fileChoose.connect('clicked',self.fileChooseCB)
        
        lab2 = gtk.Label('Input file:')
        lab2.set_alignment(1,0.5)
        table.attach(lab2,0,1,0,1,xoptions=gtk.FILL)
        table.attach(self.fileInput,1,3,0,1,xpadding=3)
        table.attach(self.fileChoose,3,4,0,1,xpadding=3)
        self.vBox.pack_start(table,False)        
        frame = gtk.Frame('Update options')
        table1 = gtk.Table(3,3)
        table1.attach(self.updateColors,0,1,0,1)
        table1.attach(self.updateParts,0,1,1,2)
        frame.add(table1)
        self.vBox.pack_start(frame,False)
        self.vBox.show_all()
                             
        