'''
Created on 3/gen/2012

@author: mario
'''

import gtk
import xml.parsers.expat
from BrickException import BrickException


class UpdateLdrawXML():
    '''
    parse LDraw<->LDD XML master file
    '''

    def hStartEl(self,name,attrs):
        #-------------------------------------------- let the GUI updates itself
        if gtk.events_pending():
            gtk.main_iteration(block=False)
        if name == 'LDrawMapping':
            #--------------------------------- ok, this is a start in ldraw.xml file
            self.fLdraw = True
            return
        if name == 'Material':
            if self.fLdraw:
                if (attrs.has_key('ldraw')):
                    ldraw = attrs['ldraw']
                else:
                    raise BrickException("Invalid LDraw.xml file: 'Material' with no 'ldraw' in row: "+
                                         str(self.Parser.CurrentLineNumber))
                if (attrs.has_key('lego')):
                    lego = attrs['lego']
                else:
                    raise BrickException("Invalid LDraw.xml file: 'Material' with no 'lego' in row: "+
                                         str(self.Parser.CurrentLineNumber))
                self.materials.append((lego,ldraw))
            else:
                raise BrickException("Invalid LDraw.xml file: 'Material' element outside 'LDrawMapping' in row: "
                                     +str(self.Parser.CurrentLineNumber))
        if name == 'Brick' or name == 'Assembly':
            if self.fLdraw:
                if (attrs.has_key('ldraw')):
                    ldraw = attrs['ldraw'].lower()
                else:
                    raise BrickException("Invalid LDraw.xml file: 'Brick' with no 'ldraw' in row: "+
                                         str(self.Parser.CurrentLineNumber))                       
                if (attrs.has_key('lego')):
                    try:
                        lego = int(attrs['lego'])
                    except ValueError:
                        #-------- ignore value, probably it is wrong or 'XXXXX'
                        return
                else:
                    raise BrickException("Invalid LDraw.xml file: 'Brick' with no 'lego' in row: "+
                                         str(self.Parser.CurrentLineNumber))
                self.parts.append((lego,ldraw))
            else:
                raise BrickException("Invalid LDraw.xml file: 'Brick' element outside 'LDrawMapping' in row: "
                                     +str(self.Parser.CurrentLineNumber))
                
                            
    def hEndEl(self,name):
        if name == 'LDrawMapping':
            self.fLdraw = False
            return



    def __init__(self,ldrawXml=None,materials=None,parts=None):
        '''
        Takes arguments:
        ldrawXml = file handle of ldraw xml
        materials = list of tuples for colors (lego,ldraw)
        parts = list of tuples for parts (lego,ldraw)
        '''
        
        self.ldrawXml = ldrawXml
        self.materials = materials
        self.parts = parts
        #-------------------------------------------------- creates Expat parser
        self.Parser = xml.parsers.expat.ParserCreate()
        #----------------------------------------------------- defines callbacks
        self.Parser.StartElementHandler = self.hStartEl
        self.Parser.EndElementHandler = self.hEndEl
        self.Parser.buffer_text = True
        self.partCount = 1
        self.fLdraw = False
        
    def run(self):        
        self.Parser.ParseFile(self.ldrawXml)


