'''
Created on 21/feb/2012

@author: mario
'''

import sqlite3
import tempfile
import os
import os.path
import shutil

import CatalogDB
import CatalogImportExport
from BrickException import BrickException

def UpgradeDatabases(catalogFile,newCatalog):
    #--------------------------------------------------------- opens old catalog
    oldcat = CatalogDB.CatalogDB(catalogFile)
    #-------------------------------------- create temp files for export
    xs,setFile = tempfile.mkstemp(text=True)
    #---------------------------------------------- exports sets catalog
    xs = os.fdopen(xs,'wt')
    CatalogImportExport.exportSetCatalog(oldcat, xs)
    xs.close()
    #----------------------------------------------------------- same for bricks
    xb,brickFile = tempfile.mkstemp(text=True)
    xb = os.fdopen(xb,'wt')
    CatalogImportExport.exportBrickCatalog(oldcat, xb)
    xb.close()
    oldcat.close()
    oldFile = os.path.splitext(catalogFile)[0]+'.old'
    #-------------------------------------- rename old database as "old"
    try:
        os.rename(catalogFile,oldFile)
        #------------------------- copy in place new database (or rename it)
        shutil.copy(newCatalog, catalogFile)
        #-------------------------------- re-import bricks and sets catalogs
        newcat = CatalogDB.CatalogDB(catalogFile)
        xs = open(setFile,'rt')
        ci = CatalogImportExport.importSetCatalog(xs,newcat)
        ci.run()
        xs.close()
        xb = open(brickFile,'rt')
        ci = CatalogImportExport.importBrickCatalog(xb,newcat)
        ci.run()
        xb.close()
        newcat.close()
    except (OSError, IOError, sqlite3.OperationalError):
        try:
            os.rename(oldFile,catalogFile)
        except (IOError,OSError):
            pass
        return
    #------------------------------------------------ deletes temp files
    os.unlink(setFile)
    os.unlink(brickFile)
    #------------------------------------------------ delete old catalog
    try:
        os.unlink(newCatalog)
    except (IOError,OSError):
        pass
    os.unlink(oldFile)
    